GNU bug report logs - #47207
28.0.50; decode_next_window_args crash

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: martin rudalics <rudalics@HIDDEN>; Keywords: fixed; Done: martin rudalics <rudalics@HIDDEN>; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
bug marked as fixed in version 28.1, send any further explanations to 47207 <at> debbugs.gnu.org and martin rudalics <rudalics@HIDDEN> Request was from martin rudalics <rudalics@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Added tag(s) fixed. Request was from martin rudalics <rudalics@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 18 Apr 2021 08:02:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Apr 18 04:02:05 2021
Received: from localhost ([127.0.0.1]:45216 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lY2NZ-0006an-6L
	for submit <at> debbugs.gnu.org; Sun, 18 Apr 2021 04:02:05 -0400
Received: from mout.gmx.net ([212.227.15.19]:60225)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>)
 id 1lY2NW-0006aF-Ps; Sun, 18 Apr 2021 04:02:03 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1618732915;
 bh=xUow4/2fXSe/wgE6Ml1tQByutUp53tKtsTywk8EmzGU=;
 h=X-UI-Sender-Class:Subject:From:To:Cc:References:Date:In-Reply-To;
 b=JKOWZTrCHkbXt75E82WNZMXwyi3ZGR8fyRGOLOPrtCpIy9huzEvs5vlkwczLcZL/I
 tOe2cnv+Rqr22gLpTzujm3YyV4Y9vhDJ1d/N8i+dG22j6FkPJyyvPIlpo3fD0vwA8Q
 i4MYDWa7xGsacEu1rFMIF2nJbhOk7li2TcjPmMP8=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.189]) by mail.gmx.net (mrgmx005
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1MkHMZ-1lvnT800qH-00kglL; Sun, 18
 Apr 2021 10:01:55 +0200
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
From: martin rudalics <rudalics@HIDDEN>
To: Alan Mackenzie <acm@HIDDEN>
References: <83eegdd4uz.fsf@HIDDEN>
 <ded69182-aa24-2939-aa9a-ec61889052a1@HIDDEN> <8335wsdcob.fsf@HIDDEN>
 <11b795a6-1a20-cc58-73d6-b75227dc732a@HIDDEN> <83r1kcflv6.fsf@HIDDEN>
 <b271888d-6273-d052-c788-505733bc1b72@HIDDEN> <YHXPfXQSx5Mt1JZv@ACM>
 <abb64c72-e8ef-95c0-45a5-1adf09b85b00@HIDDEN> <YHg6k94MDcoXB5z8@ACM>
 <872ab30c-3492-b523-eb4a-2f33a6c5da56@HIDDEN> <YHl08rLzz2tidQ+3@ACM>
 <0ad3d94d-2deb-0264-26b7-134d5c081ccc@HIDDEN>
Message-ID: <a216590f-dc62-17c9-6ed3-88c749dcaadf@HIDDEN>
Date: Sun, 18 Apr 2021 10:01:53 +0200
MIME-Version: 1.0
In-Reply-To: <0ad3d94d-2deb-0264-26b7-134d5c081ccc@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:ZvQgmIm5IEmI23MBWe+NXeAvLvl2P/6+p8vXnvBTgt0aj+YPr3p
 tDvEEYMsnnitTpt14e+IIlIyIbg/PPHF5CVBURmGdJDL0seDHFZw+NC+765ZLPpscJRAWIB
 0Xll/A5UAuS5pXqHjDZfeKNhFXtllS7vjyn/giP99PsHqzQY2uQdGugslL+Oz/VKSvTwWAg
 s1MK+JLpSwMXdlwqKsN/g==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:6Ax/SOM5GUQ=:/zsvLkpU6J1ns/27jCl+Yf
 orqgGaCQFiBOjiT3I79M7OSeamYB+DTDvlFqGbde67QdVnFIUMA0NaYuSJ+yYbI2hywxzPhRn
 a0V0HBvxsDO6a5uicInaUANwLqrhOOgJSRliVsCbSngm58c8uLxO/fAM1drkCtmaovFIhANoC
 65dyvX+cf8d1kFSzmeuNjpgOZ0OYziGVAaqIlTqMgh4cvV1gokfI6L2+7VpFyP/aUvJL25zjn
 jA4TOh2n2YE7+OzV5LuHK83IDRpVFwzf6saD7E9yVvte+GC4wAbjo8Y1erUsSN8KWxdgs6c6s
 eVeXH9Yzq/cKBCENjiz0rZj13jINa4MhYFMmGFZti00PhER0/77rNcOTKCrB2i0fBbAE2HTFf
 xq3E8srv2mWD0t83CblFNNXNPEOWiWcyVTyBf+sL64ktNTb7w40ZztJhYXa4Hv3XuxYoKD+K1
 0FpK8ymq5WKdFiFGnHugYkC/CVxmI4P5L96CRC3fch2c3ksdMlRB/vKzuDXf7rfKnh1aqdJMS
 hFTj6pfI0vcEoc0JU4pZQLY3v99cY15Cz5oC8FZlYmAcoSu23ZDhWv4xLf6IcYUsKeTL9SNZt
 kbjZ71K2+K552E8LP9uzwiraX2l+kLSBPTAioC25SUcO5NHXxX4JQLDKrSiF/fi+4LaiWc8aO
 3egMH9pNayWTSY24r72/8GhswJDOc4LO+3gfcNTuvZ3geeXj5GVQnRPT54t7vij9eee3zcyuU
 ANHoLEnaYK9VyEu/+kI9wVlqoSpFGtjkX4LZUYfPP012CvOVMbbYcc9D0F9vEURoKWditnXXw
 dfspuy8jSqigznyhIvPMcqrR8FY3kzGI9OmhaPiE1NaRdZSQoSFhTp+yIalmfCmgFONjTKB/a
 h8ac1mdYkARX4loNpYJwEMVM5TlkwqkLr5vIvvKYNF2td/nBZMPhZ7ndLkUpob+0DO++EX4nc
 vCrSpOZhsTui98T+LNsqNICdauvLGItH8BSpq8Kn30xRoQuEsswobPXqFc1gqNXcMw1m17GQJ
 LopUJaSwKFeZtTXbxh8V5/GgWhFvwqVDI0Dctz9Ysnr2P2fyH9TtLXklX5d8Ylcla0uXwK/8d
 o21gfappSDpZKfKBWc4tm5NH+hFDT7+dbId9f/6oTizeOEVOOOC4rltSMvxNdPXKBXRlhT6Vj
 oeZMXnbNbEIbEg2XckU0l0mVbMT7D3gmVd/+XK73IQV4WXbNooT7UVdfVHh8CstSfdCV8=
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47207
Cc: 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

tags 47207 fixed
close 47207 28.1
quit

 > It fixes that bug.  I'll check in a fix for the original Bug#47207 in a
 > couple of days.

Done now.  Closing this bug.

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 16 Apr 2021 14:43:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Apr 16 10:43:15 2021
Received: from localhost ([127.0.0.1]:41384 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lXPgh-0001BK-5u
	for submit <at> debbugs.gnu.org; Fri, 16 Apr 2021 10:43:15 -0400
Received: from mout.gmx.net ([212.227.17.22]:38689)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1lXPga-0001B1-GS
 for 47207 <at> debbugs.gnu.org; Fri, 16 Apr 2021 10:43:13 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1618584177;
 bh=0VhWVgRNa37wtnRi8ROCc0rzsp7eKiUMHCsnBlKwt/U=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=aY37IvDQEYDTb7RktIfpINAF8XtzkDO/7YON1gS/jLqdQkFjQ32kLkQkIZg7Vgvzh
 raAlzb1lRexZmmbW/YtcWTbHSIS7t4fKeOj9UYbN7hP8TyQswu6LuIQzcB6V1pHTyp
 qT1iD3zpcIFSmRVQDOOEQc3gd84h1XdhoAO15ltA=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.103] ([46.125.249.64]) by mail.gmx.net (mrgmx105
 [212.227.17.168]) with ESMTPSA (Nemesis) id 1MZTqg-1l4Jni0lBG-00WWH8; Fri, 16
 Apr 2021 16:42:57 +0200
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
To: Alan Mackenzie <acm@HIDDEN>
References: <83eegdd4uz.fsf@HIDDEN>
 <ded69182-aa24-2939-aa9a-ec61889052a1@HIDDEN> <8335wsdcob.fsf@HIDDEN>
 <11b795a6-1a20-cc58-73d6-b75227dc732a@HIDDEN> <83r1kcflv6.fsf@HIDDEN>
 <b271888d-6273-d052-c788-505733bc1b72@HIDDEN> <YHXPfXQSx5Mt1JZv@ACM>
 <abb64c72-e8ef-95c0-45a5-1adf09b85b00@HIDDEN> <YHg6k94MDcoXB5z8@ACM>
 <872ab30c-3492-b523-eb4a-2f33a6c5da56@HIDDEN> <YHl08rLzz2tidQ+3@ACM>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <0ad3d94d-2deb-0264-26b7-134d5c081ccc@HIDDEN>
Date: Fri, 16 Apr 2021 16:42:47 +0200
MIME-Version: 1.0
In-Reply-To: <YHl08rLzz2tidQ+3@ACM>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:Y5NMD03GsIQweOFy9Mtvu+BJvcwWn149d4WGCq9ukv142QUwczm
 jQ6kGoySAUTR+b/34Te7yTY5c+TFpqQuVmpoRkIRx+dEFUiHQOmHxKP4g9JTcVE4lqmUGFE
 A96sdTmqua9tvT0F/VSG2CgYa0GJ7K15IT2oywHjCMCnwwXv8U9P3cIkPVYFkmiSVtEQFgS
 XLZRiXdBnDHEs/3KnjV2Q==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:zNn50v6c2+c=:OQPGK0nmzXWrcQbEc4i6AO
 D1mvqywxTjg1mbVwI198GS4Lta5TesXNy8ZfsuOI56j3JIIz9LXDQ8YN/PxJp1debmTphh+Zo
 +ue3MyOYe5FzgNHyqppnQXXeSZABJrbzN9xe0qCFPKNuENfHo9k7Yk+2wtlHXMbgzk75OfEin
 gwWZhE3KkKWhAbUhSC4IO/BhzJ8iRHf8b2zhE9scf0Dp476o12rNidJLgxKQ7eynIOACFpCQ9
 +oZs4Fq+rvTl80XnrBJD3n+7bnZYKP3WMaGmdaZpqppi/rMpP382PDX+5ye8/weogCgE912kh
 GRZ2wAwv9/484XEvLSbxqewqf3DK3wV1sdimCBsoSwjf6g2Xbcg0HoeJMuS/JmTWZBnmNp8/Y
 pyRLYs/3GNtVCQt0KrpUN8fthrUDOKuycuZFftb8tfqf0IAiftR0/+Y7gfP2TkSBB2qe/ilK9
 XJ4ekHIxpegc81AZ6h1BtKHmG8fatgaVGM5LQrdGDZnRsz2SHuYidUrtcGJUaIiFgAWH0UCd8
 jCG2QxhdX/hyA/adixpu9qeOKoVWfzs2U/TZAAZ2qd7sZbe2rGv6u6dI5KmU6FLTJfilfmXKV
 LgV8iunN4gXVBQFcOP/WCVu/wvDX30Dq4wK680dnsjHjPf/r9TrYMJi16j8Yu8FqljzSo3N9X
 tatDxgsOAFmigG4W5y1+rMMNNRuxAs+w3pcN1YZ8/VLUfWpHmoBSbZEPxyqkK+pnjalneIlyq
 rEE9ybf+9pmJczddTKQxp7BGpU5OfAd/fsl7cq6ieO90WWKuzrqnq4EhqNnWfGYxjhct1k8KG
 g2XGZ2GCC0JbrYDv5fecuN5BhIzQ0YAXsaIM18JMIfpju2y3UjSvYqnYQr2iey/t4Qz+Obd9E
 BW5G1RS78TN/ZI9VasdzEUgWdDu1reYgNn0UKuRrNC8rghTnTY8rNAyhgl8/r5Z2+8TR6Ac1r
 s16if9MWikMjFgAzOwjioAm99qO4vbyeK0vHJ0Lmq0i2ugODdBKpeLaQuU/8OdUoKwJiV2bUC
 QD1lnTO+M2D4J5MvflbUgf5h2ZRoXPXE4K7fsmHiHnOZ8vaFfUj0mF4W53ezEjcffr4SuhNl1
 KwGpU+SPjGK4Egd11wD5H/m+lK3CfZj34vb//NId3j16HYWYXioB9vssqVNA/t7RtYqNN7Wq6
 c2fFqI3qoP1sZODiRU0keLL5wKjyhiB6G82CMhhFZVuZMXTCslSpvvmNVmTnNonXKYcFo=
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47207
Cc: Eli Zaretskii <eliz@HIDDEN>, 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 > Could you please look at my patch (below).  It seems to fix the bug you
 > gave a recipe for a couple of posts back.  I'm hoping it can be
 > committed as it is.

It fixes that bug.  I'll check in a fix for the original Bug#47207 in a
couple of days.

Thanks, martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 16 Apr 2021 11:29:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Apr 16 07:29:00 2021
Received: from localhost ([127.0.0.1]:40180 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lXMei-0002TZ-6F
	for submit <at> debbugs.gnu.org; Fri, 16 Apr 2021 07:29:00 -0400
Received: from colin.muc.de ([193.149.48.1]:37546 helo=mail.muc.de)
 by debbugs.gnu.org with smtp (Exim 4.84_2)
 (envelope-from <acm@HIDDEN>) id 1lXMeg-0002TJ-5C
 for 47207 <at> debbugs.gnu.org; Fri, 16 Apr 2021 07:28:59 -0400
Received: (qmail 64281 invoked by uid 3782); 16 Apr 2021 11:28:51 -0000
Received: from acm.muc.de (p4fe15aa2.dip0.t-ipconnect.de [79.225.90.162])
 (using STARTTLS) by colin.muc.de (tmda-ofmipd) with ESMTP;
 Fri, 16 Apr 2021 13:28:51 +0200
Received: (qmail 6211 invoked by uid 1000); 16 Apr 2021 11:28:51 -0000
Date: Fri, 16 Apr 2021 11:28:50 +0000
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
Message-ID: <YHl08rLzz2tidQ+3@ACM>
References: <83eegdd4uz.fsf@HIDDEN>
 <ded69182-aa24-2939-aa9a-ec61889052a1@HIDDEN>
 <8335wsdcob.fsf@HIDDEN>
 <11b795a6-1a20-cc58-73d6-b75227dc732a@HIDDEN>
 <83r1kcflv6.fsf@HIDDEN>
 <b271888d-6273-d052-c788-505733bc1b72@HIDDEN>
 <YHXPfXQSx5Mt1JZv@ACM>
 <abb64c72-e8ef-95c0-45a5-1adf09b85b00@HIDDEN>
 <YHg6k94MDcoXB5z8@ACM>
 <872ab30c-3492-b523-eb4a-2f33a6c5da56@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <872ab30c-3492-b523-eb4a-2f33a6c5da56@HIDDEN>
X-Submission-Agent: TMDA/1.3.x (Ph3nix)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 47207
Cc: Eli Zaretskii <eliz@HIDDEN>, 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hello, Martin.

On Thu, Apr 15, 2021 at 16:45:20 +0200, martin rudalics wrote:
>  > That's quite an involved thread.  I've read through it, but can't
>  > remember seeing a firm decision on how to fix the problem, or even
>  > if it was fixed then.

> It wasn't fixed then.

Ah.

>  > The current problem in minibuf.c seems to be that we assume
>  > f->minibuffer_window to be non-nil in several (~6) places, rather
>  > than checking it.

> We assume that it is a live window.

Indeed, yes.

>  > In most of these places, if we detect NILP (f->m_w), we can simply skip
>  > the action we were intending to take.  This is certainly the case in the
>  > bit that gave you the trouble in read_minibuf_unwind, where we're
>  > stepping through all frames looking for the expired minibuffer.

> The most secure way is to skip the action whenever f->minibuffer_window
> fails the WINDOW_LIVE_P check.

OK, DONE.

>  > It might well be that we never call do_switch_frame to a tool-tip frame,
>  > for example.  Do you know if this is the case?  This could save some
>  > checking code.

> I wrote some code that avoids that a tooltip window ever gets selected
> and do_switch_frame returns silently when asked to switch to a tooltip
> frame.  But I wouldn't rely on that - the display engine might still try
> to select a tooltip window for some reason.

OK.

>  > So, where do we go from here?  I'm quite willing to make these changes
>  > to minibuf.c.  Would that be OK with everybody else?

> It would be OK with me (and should fix Bug#47774 too).

Could you please look at my patch (below).  It seems to fix the bug you
gave a recipe for a couple of posts back.  I'm hoping it can be
committed as it is.

> And please look into Bug#47781 next.

OK.



diff --git a/src/minibuf.c b/src/minibuf.c
index c9831fd50f..a3c1b99bf3 100644
--- a/src/minibuf.c
+++ b/src/minibuf.c
@@ -112,13 +112,15 @@ choose_minibuf_frame (void)
 {
   if (FRAMEP (selected_frame)
       && FRAME_LIVE_P (XFRAME (selected_frame))
+      && WINDOW_LIVE_P (XFRAME (selected_frame)->minibuffer_window)
       && !EQ (minibuf_window, XFRAME (selected_frame)->minibuffer_window))
     {
       struct frame *sf = XFRAME (selected_frame);
-      /* I don't think that any frames may validly have a null minibuffer
-	 window anymore.  */
-      if (NILP (sf->minibuffer_window))
-	emacs_abort ();
+      /* I don't think that any frames may validly have a null
+	 minibuffer window anymore.  (2021-04-15): Tooltip frames have
+	 a null MB.  Comment out the following.  */
+      /* if (NILP (sf->minibuffer_window)) */
+      /* 	emacs_abort (); */
 
       minibuf_window = sf->minibuffer_window;
     }
@@ -195,7 +197,9 @@ move_minibuffers_onto_frame (struct frame *of, bool for_deletion)
 	&& (for_deletion || minibuf_follows_frame () || FRAME_INITIAL_P (of))))
     return;
   if (FRAME_LIVE_P (f)
-      && !EQ (f->minibuffer_window, of->minibuffer_window))
+      && !EQ (f->minibuffer_window, of->minibuffer_window)
+      && WINDOW_LIVE_P (f->minibuffer_window) /* F not a tootip frame */
+      && WINDOW_LIVE_P (of->minibuffer_window))
     {
       zip_minibuffer_stacks (f->minibuffer_window, of->minibuffer_window);
       if (for_deletion && XFRAME (MB_frame) != of)
@@ -636,6 +640,7 @@ read_minibuf (Lisp_Object map, Lisp_Object initial, Lisp_Object prompt,
   mini_frame = WINDOW_FRAME (XWINDOW (minibuf_window));
 
   if (minibuf_level > 1
+      && WINDOW_LIVE_P (XFRAME (MB_frame)->minibuffer_window)
       && !EQ (XWINDOW (XFRAME (selected_frame)->minibuffer_window)->frame,
 	      MB_frame)
       && minibuf_moves_frame_when_opened ()
@@ -908,11 +913,13 @@ read_minibuf (Lisp_Object map, Lisp_Object initial, Lisp_Object prompt,
   unbind_to (count, Qnil);
 
   /* Switch the frame back to the calling frame.  */
-  if ((!EQ (selected_frame, calling_frame)
-       || !EQ (XWINDOW (XFRAME (calling_frame)->minibuffer_window)->frame,
-	       calling_frame))
-      && FRAMEP (calling_frame)
-      && FRAME_LIVE_P (XFRAME (calling_frame)))
+  if (FRAMEP (calling_frame)
+      && FRAME_LIVE_P (XFRAME (calling_frame))
+      && (!EQ (selected_frame, calling_frame)
+	  || (WINDOW_LIVE_P (XFRAME (calling_frame)->minibuffer_window)
+	      && !EQ (XWINDOW (XFRAME (calling_frame)->minibuffer_window)
+		      ->frame,
+		      calling_frame))))
     call2 (intern ("select-frame-set-input-focus"), calling_frame, Qnil);
 
   /* Add the value to the appropriate history list, if any.  This is
@@ -1056,10 +1063,13 @@ read_minibuf_unwind (void)
     {
       f = XFRAME (exp_MB_frame);
       window = f->minibuffer_window;
-      w = XWINDOW (window);
-      if (EQ (w->frame, exp_MB_frame)
-	  && EQ (w->contents, nth_minibuffer (minibuf_level)))
-	goto found;
+      if (WINDOW_LIVE_P (window))
+	{
+	  w = XWINDOW (window);
+	  if (EQ (w->frame, exp_MB_frame)
+	      && EQ (w->contents, nth_minibuffer (minibuf_level)))
+	    goto found;
+	}
     }
   return; /* expired minibuffer not found.  Maybe we should output an
 	     error, here. */


> martin

-- 
Alan Mackenzie (Nuremberg, Germany).




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 16 Apr 2021 00:15:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Apr 15 20:15:16 2021
Received: from localhost ([127.0.0.1]:39595 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lXC8i-0006kx-Ml
	for submit <at> debbugs.gnu.org; Thu, 15 Apr 2021 20:15:16 -0400
Received: from heytings.org ([95.142.160.155]:39868)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <gregory@HIDDEN>) id 1lXC8h-0006kp-AA
 for 47207 <at> debbugs.gnu.org; Thu, 15 Apr 2021 20:15:15 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=heytings.org;
 s=20210101; t=1618532113;
 bh=SLs92xzHJplbVh6RB81r1mdZivpUA2R8tQvqIxQBO9s=;
 h=Date:From:To:cc:Subject:In-Reply-To:Message-ID:References:From;
 b=HrN1EZ52+C9NWogmTG6rJquMzoAU6B+gj1AKYpsHrfbA5tOSs/dOAyL5Wsr+3CMpw
 a7NJJx3EF242gZ+cjRTgV2s6Joo5/LFtMka8+yjec0MAFoUwoU+ay32lOlDUERHXwW
 NFi2AV7DmSuidYFVS6Xzds6UxJE5PDUNequJDb/jBsX1ZtyhyFXYx3aN3lxoQNQVtj
 D6iVvUm8lyeo0EWzSqQYoHGUJ8kiYmc7HZZGLTvYiTM7jXiI5woUAnByBDNAc31o//
 dTBiZ78d2ZBf8pkMlOTJfP5E/GWsyVTb3VMv/K6tAHcEppJ4BwDowtLJeC6cxaUAGa
 HRIbqMTKUwBXw==
Date: Fri, 16 Apr 2021 00:15:13 +0000
From: Gregory Heytings <gregory@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
In-Reply-To: <872ab30c-3492-b523-eb4a-2f33a6c5da56@HIDDEN>
Message-ID: <7dee3f4235d5c29fd3fc@HIDDEN>
References: <83h7l9d651.fsf@HIDDEN>
 <ea56065e-eccc-b6fe-e1ba-671f8352986d@HIDDEN> <83eegdd4uz.fsf@HIDDEN>
 <ded69182-aa24-2939-aa9a-ec61889052a1@HIDDEN> <8335wsdcob.fsf@HIDDEN>
 <11b795a6-1a20-cc58-73d6-b75227dc732a@HIDDEN> <83r1kcflv6.fsf@HIDDEN>
 <b271888d-6273-d052-c788-505733bc1b72@HIDDEN> <YHXPfXQSx5Mt1JZv@ACM>
 <abb64c72-e8ef-95c0-45a5-1adf09b85b00@HIDDEN> <YHg6k94MDcoXB5z8@ACM>
 <872ab30c-3492-b523-eb4a-2f33a6c5da56@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed; charset=us-ascii
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 47207
Cc: 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


>> So, where do we go from here?  I'm quite willing to make these changes 
>> to minibuf.c.  Would that be OK with everybody else?
>
> It would be OK with me (and should fix Bug#47774 too).  And please look 
> into Bug#47781 next.
>

Not with me, FWIW.  The minibuffer was perfectly functional before commit 
2ecbf4cfae.  Backward incompatible changes and bugs were introduced since 
then.  The current state of affairs is rather sad; as you said, it's the 
first time in several years that you've been losing Emacs sessions. 
That's quite a high price for a small feature that nobody requested.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 15 Apr 2021 14:45:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Apr 15 10:45:34 2021
Received: from localhost ([127.0.0.1]:38853 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lX3FO-00038Q-8y
	for submit <at> debbugs.gnu.org; Thu, 15 Apr 2021 10:45:34 -0400
Received: from mout.gmx.net ([212.227.17.22]:58807)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1lX3FJ-000386-4L
 for 47207 <at> debbugs.gnu.org; Thu, 15 Apr 2021 10:45:33 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1618497921;
 bh=GEID7luB0jjjh6Keta6DYduHI2Y8BOF5GJwCAxdxATw=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=JR6WxGBGByUIqjfDwi25TvrzmwzCj92TGN4swx006CAsPwT1i+QuwlsVOjjE4ld9D
 z9yJ/r0pTtU1+hIdU57wbTbSAok49fAUowPXTT6A/CgBUM/z8/qMZ6oFGH8NgKLqRa
 81D/YODRZnDXDoei1INBMAKIu/6nvBERbArffZHo=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.198]) by mail.gmx.net (mrgmx104
 [212.227.17.168]) with ESMTPSA (Nemesis) id 1N9MpY-1lcdoT2WEW-015ItI; Thu, 15
 Apr 2021 16:45:21 +0200
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
To: Alan Mackenzie <acm@HIDDEN>
References: <83h7l9d651.fsf@HIDDEN>
 <ea56065e-eccc-b6fe-e1ba-671f8352986d@HIDDEN> <83eegdd4uz.fsf@HIDDEN>
 <ded69182-aa24-2939-aa9a-ec61889052a1@HIDDEN> <8335wsdcob.fsf@HIDDEN>
 <11b795a6-1a20-cc58-73d6-b75227dc732a@HIDDEN> <83r1kcflv6.fsf@HIDDEN>
 <b271888d-6273-d052-c788-505733bc1b72@HIDDEN> <YHXPfXQSx5Mt1JZv@ACM>
 <abb64c72-e8ef-95c0-45a5-1adf09b85b00@HIDDEN> <YHg6k94MDcoXB5z8@ACM>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <872ab30c-3492-b523-eb4a-2f33a6c5da56@HIDDEN>
Date: Thu, 15 Apr 2021 16:45:20 +0200
MIME-Version: 1.0
In-Reply-To: <YHg6k94MDcoXB5z8@ACM>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:IejzjYGMzEfVFOoVrjJzwY90qNqT9f6Z4Cx5dQ8xAadNnPTWxaf
 vViCsLLFstPMVyX/Xt5hSokIyXQiBOMPCW5m1iIM65Svdi+1L58o4+qO34cxlP0U1ffqAOf
 ATzGgFTFUVIkElVb672CjpM9BwcAAUdnzwGAO232VRx9OHxCdUQ+uYTh4G5D+Dm3RQ76SSV
 6TnHlSFBVE47Aedr0v8IQ==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:/8DzKbG2K84=:msiHMfmz/mkZA5qq+zGHbp
 7XlvOFs2frE8F5mfS9Z3F0K46ID2pLrKqMVEyBgLuQApgybhEsWUHuPH5n458KLMtxBb3AeT5
 yjJLxt1vmM6yOj8dUm89wEJo515qQ5WQDE2C1ieozU8jIhV4/onaSfvKlbR18mHdw1KQaECUj
 z3IiO4WkZQgK8zkpULIdK53lXbDgW0AraCrc45xOaf7uaHQT7mUqjH5iVzJXkWbdVBs29iDnS
 F/PFpn+0F+pEMfdZDevz9vSbvQVLQ3YR4geqGBXeyzt+eyIwc37RO1CrpJgJkMYsoIktzvNLq
 LTPYMxnrQn6Gz8Z47sWFZ0kkj3dVaPa49aoSmIQ1UHwJs824vvHTv61dULAAsAJWonWfD7Pfn
 ylfBPX+6nJv3P0atUGQizosQO++Xpzl88z5CjiCZbCCc3y4GE/SfNEdDiFpVR2xSi+LlYarQw
 QdSnshExbCnwcyPGP/cVQJUUHjnyZQ2oqi1iFVrogUNE106ILB/rRhXBM9j3VwToxNkOxeFll
 ft9WrVmWpy2vbXL17RbtV1070DOsDHW9Eto5MlSfMEnYUeam/VQRgvp+QJKw2AWc7bZ3w0VlP
 C4yxmLyg3RLGJubEkQNx1jOocpfVjy8B812/bmQB46v5Z8u05aBtJVJevKvKbYd33EdqqO0DJ
 Lx/QCPVxOYZ/OXd9ARD0+D1HJwHmYEpPkGjWiZje5Y6L2YncKhsIAawrII+MDAfX3TmFzq8WH
 lWpGydgRc1DZhCPVHun32/E/nqvoPkvEvg8KFUSVTrlWfocjFb7lZB3csIvlAtqyI/JzFJcW/
 k9mSgyZ3QyYhPLychnzrjHYSml8cweRuAhVK9tnlVN4zqBY4dADN2zYq5P0pboSen/5EDZUy1
 4CF3Y288Gw8GSmNiagj35uGwvVBwVRBrmE76vAO73krTcUsVqWLVjyyJC7l/+k2EnfxCfjUe/
 vSEIS+z2VjOXp52SViMNttrbufz+0+vpAJhPEVLwKYUhBaskWqB8i0lClfbLQYXO/W5MY90RV
 swbZhFKTA84lx+uIY5E7Kb3Vj8gkTvgv1AuI2Z0D76HjuH+asTF24I3c5HbDVkn6AJkb2Sl24
 Sk7HGBVuxF5YYeIilNGpLnpKgLUCnBfEMp9DgwhDHu5qHxezRSRhoTM+V5khzvy0nduRf03cQ
 MILJwWbt6RtnftCE/Dbb9WctuQL+qCOKj6seYl5nIM02FpjYeC472t7sPs4j6A76YI/Kws3xx
 mmx707611lcUM3EHR
X-Spam-Score: 2.9 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  > That's quite an involved thread. I've read through it,
 but can't > remember seeing a firm decision on how to fix the problem, or
 even if it > was fixed then. It wasn't fixed then. > The current problem in
 minibuf.c seems to be that we assume > f->minibuffer_window to be non-nil
 in several (~6) places, rather than > checking it. 
 Content analysis details:   (2.9 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 3.6 RCVD_IN_SBL_CSS        RBL: Received via a relay in Spamhaus SBL-CSS
 [212.95.5.198 listed in zen.spamhaus.org]
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (rudalics[at]gmx.at)
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 SPF_PASS               SPF: sender matches SPF record
 -0.7 RCVD_IN_DNSWL_LOW      RBL: Sender listed at https://www.dnswl.org/,
 low trust [212.227.17.22 listed in list.dnswl.org]
 0.0 RCVD_IN_MSPIKE_H3      RBL: Good reputation (+3)
 [212.227.17.22 listed in wl.mailspike.net]
 0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders
X-Debbugs-Envelope-To: 47207
Cc: Eli Zaretskii <eliz@HIDDEN>, 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.9 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  > That's quite an involved thread. I've read through it,
   but can't > remember seeing a firm decision on how to fix the problem, or
   even if it > was fixed then. It wasn't fixed then. > The current problem in
    minibuf.c seems to be that we assume > f->minibuffer_window to be non-nil
    in several (~6) places, rather than > checking it. 
 
 Content analysis details:   (1.9 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  0.0 RCVD_IN_MSPIKE_H3      RBL: Good reputation (+3)
                             [212.227.17.22 listed in wl.mailspike.net]
 -0.7 RCVD_IN_DNSWL_LOW      RBL: Sender listed at https://www.dnswl.org/,
                             low trust
                             [212.227.17.22 listed in list.dnswl.org]
  3.6 RCVD_IN_SBL_CSS        RBL: Received via a relay in Spamhaus SBL-CSS
                             [212.95.5.198 listed in zen.spamhaus.org]
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
                             provider (rudalics[at]gmx.at)
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 SPF_PASS               SPF: sender matches SPF record
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders

 > That's quite an involved thread.  I've read through it, but can't
 > remember seeing a firm decision on how to fix the problem, or even if it
 > was fixed then.

It wasn't fixed then.

 > The current problem in minibuf.c seems to be that we assume
 > f->minibuffer_window to be non-nil in several (~6) places, rather than
 > checking it.

We assume that it is a live window.

 > In most of these places, if we detect NILP (f->m_w), we can simply skip
 > the action we were intending to take.  This is certainly the case in the
 > bit that gave you the trouble in read_minibuf_unwind, where we're
 > stepping through all frames looking for the expired minibuffer.

The most secure way is to skip the action whenever f->minibuffer_window
fails the WINDOW_LIVE_P check.

 > It might well be that we never call do_switch_frame to a tool-tip frame,
 > for example.  Do you know if this is the case?  This could save some
 > checking code.

I wrote some code that avoids that a tooltip window ever gets selected
and do_switch_frame returns silently when asked to switch to a tooltip
frame.  But I wouldn't rely on that - the display engine might still try
to select a tooltip window for some reason.

 > So, where do we go from here?  I'm quite willing to make these changes
 > to minibuf.c.  Would that be OK with everybody else?

It would be OK with me (and should fix Bug#47774 too).  And please look
into Bug#47781 next.

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 15 Apr 2021 13:07:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Apr 15 09:07:40 2021
Received: from localhost ([127.0.0.1]:36716 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lX1ie-0008S9-Bh
	for submit <at> debbugs.gnu.org; Thu, 15 Apr 2021 09:07:40 -0400
Received: from colin.muc.de ([193.149.48.1]:20022 helo=mail.muc.de)
 by debbugs.gnu.org with smtp (Exim 4.84_2)
 (envelope-from <acm@HIDDEN>) id 1lX1ic-0008Rv-GD
 for 47207 <at> debbugs.gnu.org; Thu, 15 Apr 2021 09:07:39 -0400
Received: (qmail 88895 invoked by uid 3782); 15 Apr 2021 13:07:32 -0000
Received: from acm.muc.de (p4fe159f6.dip0.t-ipconnect.de [79.225.89.246])
 (using STARTTLS) by colin.muc.de (tmda-ofmipd) with ESMTP;
 Thu, 15 Apr 2021 15:07:32 +0200
Received: (qmail 20055 invoked by uid 1000); 15 Apr 2021 13:07:31 -0000
Date: Thu, 15 Apr 2021 13:07:31 +0000
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
Message-ID: <YHg6k94MDcoXB5z8@ACM>
References: <83h7l9d651.fsf@HIDDEN>
 <ea56065e-eccc-b6fe-e1ba-671f8352986d@HIDDEN>
 <83eegdd4uz.fsf@HIDDEN>
 <ded69182-aa24-2939-aa9a-ec61889052a1@HIDDEN>
 <8335wsdcob.fsf@HIDDEN>
 <11b795a6-1a20-cc58-73d6-b75227dc732a@HIDDEN>
 <83r1kcflv6.fsf@HIDDEN>
 <b271888d-6273-d052-c788-505733bc1b72@HIDDEN>
 <YHXPfXQSx5Mt1JZv@ACM>
 <abb64c72-e8ef-95c0-45a5-1adf09b85b00@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <abb64c72-e8ef-95c0-45a5-1adf09b85b00@HIDDEN>
X-Submission-Agent: TMDA/1.3.x (Ph3nix)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 47207
Cc: acm@HIDDEN, Eli Zaretskii <eliz@HIDDEN>, 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hello, Martin.

On Tue, Apr 13, 2021 at 19:12:41 +0200, martin rudalics wrote:
>  > OK.  There's a long-standing comment to the contrary in
>  > choose_minibuf_frame (src/minibuf.c):

>  >        /* I don't think that any frames may validly have a null
>  >         * minibuffer window anymore.  */

>  > , so it looks like that comment is no longer valid.  It needs
>  > changing/removing and the code it annotates seems to want fixing.  There
>  > might well be other places in the earlier part of minibuf.c that assume
>  > a non-null ->minibuffer_window.

>  > Either the ->minibuffer_window of tootip frames must be given a sensible
>  > non-null value (is this practicable and sensible?), or the code needs
>  > fixing to not assume it.

> See

> https://lists.gnu.org/archive/html/emacs-devel/2018-02/msg00694.html

That's quite an involved thread.  I've read through it, but can't
remember seeing a firm decision on how to fix the problem, or even if it
was fixed then.

The current problem in minibuf.c seems to be that we assume
f->minibuffer_window to be non-nil in several (~6) places, rather than
checking it.

In most of these places, if we detect NILP (f->m_w), we can simply skip
the action we were intending to take.  This is certainly the case in the
bit that gave you the trouble in read_minibuf_unwind, where we're
stepping through all frames looking for the expired minibuffer.

It might well be that we never call do_switch_frame to a tool-tip frame,
for example.  Do you know if this is the case?  This could save some
checking code.

So, where do we go from here?  I'm quite willing to make these changes
to minibuf.c.  Would that be OK with everybody else?

> martin

-- 
Alan Mackenzie (Nuremberg, Germany).




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 13 Apr 2021 17:37:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 13 13:37:39 2021
Received: from localhost ([127.0.0.1]:60695 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lWMyp-0004JM-Lv
	for submit <at> debbugs.gnu.org; Tue, 13 Apr 2021 13:37:39 -0400
Received: from heytings.org ([95.142.160.155]:37098)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <gregory@HIDDEN>) id 1lWMym-0004JB-HZ
 for 47207 <at> debbugs.gnu.org; Tue, 13 Apr 2021 13:37:37 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=heytings.org;
 s=20210101; t=1618335453;
 bh=1t97APtVV8nKy3Q6kb7TYEkFfI6MuDKiu7+LIrnd9bU=;
 h=Date:From:To:cc:Subject:In-Reply-To:Message-ID:References:From;
 b=eKz8F5sKiVHpjyzQHqkqP5v7nZYeggV71+iQ4sXLA1TxzfCDyOMtWZHbzwvHbZiCi
 NGHOz/fwqV29qkFb3j0rApkSQ3habBS2Cre48HlwyhBF0LTepMCh8XBbZhuOQgenYU
 1ZfNsTbgDu0LJYhG6mrNUweKEVLAJmyNAmsrrtATZMTJ98kA6MNSqnA8nJ0ymnc7Jq
 zadbk6pyZdpX4CgwdghMYuEnPGiCHN4Mct7ccOVVIFaL2D3HW4aUqyiELBxbPQMH3w
 iUIGeYFfaMctiPb/V4CxqOhVIng9Q71PglCfsthXqnjtnzSuzLrhbFEd3toDxPKEVp
 sGqCYvQHXWEvg==
Date: Tue, 13 Apr 2021 17:37:33 +0000
From: Gregory Heytings <gregory@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
In-Reply-To: <b271888d-6273-d052-c788-505733bc1b72@HIDDEN>
Message-ID: <2725e560cfed6e6c936b@HIDDEN>
References: <c8442033-ac9b-f9e0-d5f5-3d649a874c3f@HIDDEN>
 <83r1kddi2r.fsf@HIDDEN> <37300876-70d1-c741-8a4d-97d024fdf6cf@HIDDEN>
 <83k0q5dbml.fsf@HIDDEN> <64dca5b5-1234-9176-dcfe-b42d6eea2caa@HIDDEN>
 <83h7l9d651.fsf@HIDDEN> <ea56065e-eccc-b6fe-e1ba-671f8352986d@HIDDEN>
 <83eegdd4uz.fsf@HIDDEN> <ded69182-aa24-2939-aa9a-ec61889052a1@HIDDEN>
 <8335wsdcob.fsf@HIDDEN> <11b795a6-1a20-cc58-73d6-b75227dc732a@HIDDEN>
 <83r1kcflv6.fsf@HIDDEN> <b271888d-6273-d052-c788-505733bc1b72@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii; format=flowed
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 47207
Cc: acm@HIDDEN, Eli Zaretskii <eliz@HIDDEN>, 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


>
> Having just managed to "solve this issue" here in a more or less elegant 
> way, Alan beat me to it with a new twist.  To reproduce with emacs -Q do
>
> (custom-set-variables
> '(tooltip-reuse-hidden-frame t)
> '(x-gtk-use-system-tooltips nil))
>
> show a tooltip (by moving the mouse over the mode line for example) and 
> then type C-h f followed by C-g.
>

This is because of commit 7c2ebf6e23.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 13 Apr 2021 17:12:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 13 13:12:56 2021
Received: from localhost ([127.0.0.1]:60672 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lWMat-0003hR-U9
	for submit <at> debbugs.gnu.org; Tue, 13 Apr 2021 13:12:56 -0400
Received: from mout.gmx.net ([212.227.15.15]:38505)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1lWMas-0003hC-S2
 for 47207 <at> debbugs.gnu.org; Tue, 13 Apr 2021 13:12:55 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1618333966;
 bh=bfXOJMX8vnH2EIBzM4qQnugrc6BAZK2a7MoC84Uz6b0=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=O1CCJghzIkqlQGIWMEZ3F1GA3AqaFZu5ezqWtG4SEBJLzdCsaaF5hIFTWgnVmwMNI
 FSY4WUDmV8E1AEx5edaK9vMPA+cR7LyTgztFguQ9zV3icfO3CRZEx8T2QXjDh+K+uh
 PSpIiFw96u9l5BTLVr3rmdvoO+LcZm4EV/JxIN1Y=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.103] ([213.162.73.172]) by mail.gmx.net (mrgmx005
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1N33Ed-1lfpR50nwT-013MKn; Tue, 13
 Apr 2021 19:12:46 +0200
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
To: Alan Mackenzie <acm@HIDDEN>
References: <83k0q5dbml.fsf@HIDDEN>
 <64dca5b5-1234-9176-dcfe-b42d6eea2caa@HIDDEN> <83h7l9d651.fsf@HIDDEN>
 <ea56065e-eccc-b6fe-e1ba-671f8352986d@HIDDEN> <83eegdd4uz.fsf@HIDDEN>
 <ded69182-aa24-2939-aa9a-ec61889052a1@HIDDEN> <8335wsdcob.fsf@HIDDEN>
 <11b795a6-1a20-cc58-73d6-b75227dc732a@HIDDEN> <83r1kcflv6.fsf@HIDDEN>
 <b271888d-6273-d052-c788-505733bc1b72@HIDDEN> <YHXPfXQSx5Mt1JZv@ACM>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <abb64c72-e8ef-95c0-45a5-1adf09b85b00@HIDDEN>
Date: Tue, 13 Apr 2021 19:12:41 +0200
MIME-Version: 1.0
In-Reply-To: <YHXPfXQSx5Mt1JZv@ACM>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:EySh4G/Z6Fp5D7YtSz5v2lqtakG+hYNxu0RAdAVw7klR5nepDmq
 xBoogqvafsFLJuh1/juOLCcspspwAR0jsKwoMTCgpNlBIFgoEGXUNqX7GkCdfbJ/47OdSGq
 QLeQdUvNrhmwrPIMee46bwzBbP7pNKsfn2R9gQxxIK67BZX26d40pUiiOCX1EJ1XJ+83yzl
 VWutHKdfomONyKcRxjMyw==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:j8OcPtgRMwU=:atWDed84n5ruE7tgT49TR0
 JFNg6GXP85G7uKHL3OesmLwAC6y20N8Ooym5I/xEdPo/k/dTKfTBbcH9Nu4e/RQOTvP/BT2tz
 LVsRH2IiM3e3peXWb9bMv6+8+bc7TY34S7kh9UcLq9TR2QMuzIGry1muOqeQBHZoSwuKRY9rP
 OG7vTNUDuMqKqhGHXWoYrdPzzXp8+olqoAr/5Bmm7MgcL+jiA7DAyk7Oe1EdAB5+Yt7g51ni5
 7Bl0vRRXcjl2fmpFuFQaOTXqdmTb4C2Zr8xIASkR1qQBLuAvryJ0rLQtiqYBBDNKFX8LI4C9Y
 Z0ExRH7lAP3JDRvgtac9kJLvweur9zPzoHOquBI5DcitnNKmir+2W5B53JQsfBQl24ICrTmye
 TYI8nPtdn3o39sHwXiObi2ZKsPg24W+vupkD3XdLnkohw/QfjAtRZJDrPKiUWvz2lC678L90i
 4w8WEuG1UtnokakImAUGGelFGM4uwKzc957NmzWW4Jy6ot4dqUzCLfBT4qPbllNVHH0dbc2qC
 DKuw14OP9L1V8adicT/pkxT72T2HajuyImoQPZEZ9rR508S80dsGxKbzPfmuMU3cnW9Bu0+AH
 yZ4EfyvJELwpzQbwPI9leju1E62P6gXOYr0DfTfrndQzSKVha2XbdD+T5kq/SuZ+ZqoUXa+8T
 sp/zb601WSEO4LtuR6Kik5x3J00Smd+4KYi3dzkbUiu783eRY2MLRFrP8XBhFKdTPyqz3Ndnl
 LPVLPH8+CWIZC8R5K1qJJTtvS8KU/fo/Wz9/Um/k7v8i0PitW3mn/LVzRV7ljpfhVujDm5xtB
 ewhBTNGwOpa9OPt+xm29aRXg78SSHBR2+YCt2pj20NoDvV2yV51QmlafDno49NXFIQXccuVbr
 mBBLefzJyhA+Xw3IbOSru3tz2DoU+He2cLUnPw5ilqVzOeFvxno3lDiWtPuxrJI4VsfRb/MPG
 fRwAd75ZRERkCfh9k21iFNjPl1qGcjJMspt3Ex/SyyKV46L776uSQsB/tRl2iC1mEBRrpNRym
 MYOEJhER5TKvtHFee5aOAEyTbfBj22duSR+d/WpAMTwsFeks0vQoxY7wKtiCQeMe8CyZB6+CD
 bLGQWEbMY5dQ3VZ+imp18/DNjllxxTCcCo9xKJ5fMPQ/2A628K7JedNjHZxKzOJUFBgt2OkTO
 LiJHDb1BG3cbQr1m/MyhI2IJjmKwH3Z/MoHYZLQqO8bcFU9w/06e82YP9JVHcFSNw0OLI=
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 47207
Cc: Eli Zaretskii <eliz@HIDDEN>, 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

 > OK.  There's a long-standing comment to the contrary in
 > choose_minibuf_frame (src/minibuf.c):
 >
 >        /* I don't think that any frames may validly have a null
 >         * minibuffer window anymore.  */
 >
 > , so it looks like that comment is no longer valid.  It needs
 > changing/removing and the code it annotates seems to want fixing.  There
 > might well be other places in the earlier part of minibuf.c that assume
 > a non-null ->minibuffer_window.
 >
 > Either the ->minibuffer_window of tootip frames must be given a sensible
 > non-null value (is this practicable and sensible?), or the code needs
 > fixing to not assume it.

See

https://lists.gnu.org/archive/html/emacs-devel/2018-02/msg00694.html

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 13 Apr 2021 17:06:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 13 13:06:14 2021
Received: from localhost ([127.0.0.1]:60660 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lWMUQ-0003XK-4B
	for submit <at> debbugs.gnu.org; Tue, 13 Apr 2021 13:06:14 -0400
Received: from colin.muc.de ([193.149.48.1]:63901 helo=mail.muc.de)
 by debbugs.gnu.org with smtp (Exim 4.84_2)
 (envelope-from <acm@HIDDEN>) id 1lWMUN-0003X6-MC
 for 47207 <at> debbugs.gnu.org; Tue, 13 Apr 2021 13:06:12 -0400
Received: (qmail 51772 invoked by uid 3782); 13 Apr 2021 17:06:05 -0000
Received: from acm.muc.de (p4fe15996.dip0.t-ipconnect.de [79.225.89.150])
 (using STARTTLS) by colin.muc.de (tmda-ofmipd) with ESMTP;
 Tue, 13 Apr 2021 19:06:05 +0200
Received: (qmail 12303 invoked by uid 1000); 13 Apr 2021 17:06:05 -0000
Date: Tue, 13 Apr 2021 17:06:05 +0000
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
Message-ID: <YHXPfXQSx5Mt1JZv@ACM>
References: <83k0q5dbml.fsf@HIDDEN>
 <64dca5b5-1234-9176-dcfe-b42d6eea2caa@HIDDEN>
 <83h7l9d651.fsf@HIDDEN>
 <ea56065e-eccc-b6fe-e1ba-671f8352986d@HIDDEN>
 <83eegdd4uz.fsf@HIDDEN>
 <ded69182-aa24-2939-aa9a-ec61889052a1@HIDDEN>
 <8335wsdcob.fsf@HIDDEN>
 <11b795a6-1a20-cc58-73d6-b75227dc732a@HIDDEN>
 <83r1kcflv6.fsf@HIDDEN>
 <b271888d-6273-d052-c788-505733bc1b72@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <b271888d-6273-d052-c788-505733bc1b72@HIDDEN>
X-Submission-Agent: TMDA/1.3.x (Ph3nix)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 47207
Cc: Eli Zaretskii <eliz@HIDDEN>, 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hello, Martin.

On Tue, Apr 13, 2021 at 17:54:55 +0200, martin rudalics wrote:
>   and developers don't care.>> Because in my crash scenario (other-window 1 t) selects the tooltip
>  >> window.

>  > OK, then solving this issue will solve that as well, I guess.

> Having just managed to "solve this issue" here in a more or less elegant
> way, Alan beat me to it with a new twist.  To reproduce with emacs -Q do

> (custom-set-variables
>   '(tooltip-reuse-hidden-frame t)
>   '(x-gtk-use-system-tooltips nil))

> show a tooltip (by moving the mouse over the mode line for example) and
> then type C-h f followed by C-g.  Here this gets me

> Thread 1 "emacs" hit Breakpoint 1, terminate_due_to_signal (sig=6, backtrace_limit=2147483647) at ../../src/emacs.c:399
> 399	  signal (sig, SIG_DFL);
> (gdb) bt
> #0  0x00000000005a6c28 in terminate_due_to_signal (sig=6, backtrace_limit=2147483647) at ../../src/emacs.c:399
> #1  0x0000000000653420 in die (msg=0x7d01d6 "WINDOWP (a)", file=0x7d01c3 "../../src/window.h", line=543) at ../../src/alloc.c:7420
> #2  0x00000000006006d2 in XWINDOW (a=XIL(0)) at ../../src/window.h:543
> #3  0x00000000006039ae in read_minibuf_unwind () at ../../src/minibuf.c:1060
> #4  0x000000000068e80e in do_one_unbind (this_binding=0x7fffffffc880, unwinding=true, bindflag=SET_INTERNAL_UNBIND) at ../../src/eval.c:3594
> #5  0x000000000068ebc9 in unbind_to (count=3, value=XIL(0)) at ../../src/eval.c:3717
> #6  0x00000000006877a5 in unwind_to_catch (catch=0xd99a40, type=NONLOCAL_EXIT_SIGNAL, value=XIL(0x2eb09c3)) at ../../src/eval.c:1254
> #7  0x0000000000688dda in signal_or_quit (error_symbol=XIL(0xb5e0), data=XIL(0), keyboard_quit=true) at ../../src/eval.c:1784
> #8  0x00000000006888df in quit () at ../../src/eval.c:1664
> #9  0x00000000005ad8c5 in recursive_edit_1 () at ../../src/keyboard.c:722
> #10 0x0000000000602e27 in read_minibuf (map=XIL(0x7ffff409d9f3), initial=XIL(0), prompt=XIL(0x10b6304), expflag=false, histvar=XIL(0x9ae0), histpos=make_fixnum(0), defalt=XIL(0x7ffff437cb7c), allow_props=false, inherit_input_method=false) at ../../src/minibuf.c:871
> #11 0x00000000006044a0 in Fread_from_minibuffer (prompt=XIL(0x10b6304), initial_contents=XIL(0), keymap=XIL(0x7ffff409d9f3), read=XIL(0), hist=XIL(0), default_value=XIL(0x7ffff437cb7c), inherit_input_method=XIL(0)) at ../../src/minibuf.c:1312
> #12 0x000000000068ca11 in funcall_subr (subr=0xc54d00 <Sread_from_minibuffer>, numargs=7, args=0x7fffffffcd70) at ../../src/eval.c:3011

[ .... ]

> Lisp Backtrace:
> "read-from-minibuffer" (0xffffcd70)
> "completing-read-default" (0xffffd2c8)
> "completing-read" (0xffffd448)
> "byte-code" (0xffffd8a0)
> "call-interactively" (0xffffdd40)
> "command-execute" (0xffffe2a8)
> (gdb)

> I can easily sidestep this in read_minibuf_unwind via

>    FOR_EACH_FRAME (frames, exp_MB_frame)
>      {
>        f = XFRAME (exp_MB_frame);
>        if (!FRAME_TOOLTIP_P (f))
> 	{
> 	  window = f->minibuffer_window;
> 	  w = XWINDOW (window);
> 	  if (EQ (w->frame, exp_MB_frame)
> 	      && EQ (w->contents, nth_minibuffer (minibuf_level)))
> 	    goto found;
> 	}
>      }

> but the underlying issue remains: Not every frame has a minibuffer
> window.

OK.  There's a long-standing comment to the contrary in
choose_minibuf_frame (src/minibuf.c):

      /* I don't think that any frames may validly have a null
       * minibuffer window anymore.  */

, so it looks like that comment is no longer valid.  It needs
changing/removing and the code it annotates seems to want fixing.  There
might well be other places in the earlier part of minibuf.c that assume
a non-null ->minibuffer_window.

Either the ->minibuffer_window of tootip frames must be given a sensible
non-null value (is this practicable and sensible?), or the code needs
fixing to not assume it.

> martin

-- 
Alan Mackenzie (Nuremberg, Germany).




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 13 Apr 2021 15:55:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 13 11:55:13 2021
Received: from localhost ([127.0.0.1]:60600 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lWLNh-0001p3-19
	for submit <at> debbugs.gnu.org; Tue, 13 Apr 2021 11:55:13 -0400
Received: from mout.gmx.net ([212.227.15.18]:42255)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1lWLNf-0001on-MY
 for 47207 <at> debbugs.gnu.org; Tue, 13 Apr 2021 11:55:12 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1618329303;
 bh=97EwqQLPxu+pAQ9nH7vUEW7AK2ZhI+oOJNAerW23Er0=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=Qn1nHuoNj22BK0kZst8NsgNi1a+NoZjmyNV75gAjh+PKbKNajYGCz6CdCXuEOZeTp
 WtSnD4fVfzwmTj6SoCiGiE4KoBkSiLIaQuhcb52vqnGJ1+msmHWrBroklo6Dyf9Km/
 9nkHiltOxHrqz/Uxnh9TjkVrV8+IJR0CYGfcwyuk=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.103] ([213.162.73.172]) by mail.gmx.net (mrgmx005
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1MJVHe-1lH0Ly0klk-00JqFl; Tue, 13
 Apr 2021 17:54:58 +0200
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
To: Eli Zaretskii <eliz@HIDDEN>
References: <c8442033-ac9b-f9e0-d5f5-3d649a874c3f@HIDDEN>
 <83r1kddi2r.fsf@HIDDEN> <37300876-70d1-c741-8a4d-97d024fdf6cf@HIDDEN>
 <83k0q5dbml.fsf@HIDDEN> <64dca5b5-1234-9176-dcfe-b42d6eea2caa@HIDDEN>
 <83h7l9d651.fsf@HIDDEN> <ea56065e-eccc-b6fe-e1ba-671f8352986d@HIDDEN>
 <83eegdd4uz.fsf@HIDDEN> <ded69182-aa24-2939-aa9a-ec61889052a1@HIDDEN>
 <8335wsdcob.fsf@HIDDEN> <11b795a6-1a20-cc58-73d6-b75227dc732a@HIDDEN>
 <83r1kcflv6.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <b271888d-6273-d052-c788-505733bc1b72@HIDDEN>
Date: Tue, 13 Apr 2021 17:54:55 +0200
MIME-Version: 1.0
In-Reply-To: <83r1kcflv6.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:WWxseck+MWYPByTm2jQkEt3MUOO8/gSC6gqxVmfLIF7m+uFi1ut
 C7/9mSpLRpBT2cdR7xc54C/Ba4r9vRnCo1nZnNbvq2jqxjubfYO9t/7bri25TtRtuiBR699
 p0yXVvzHN0DvLpHfstZ8TnwhPmLt74RssiWh5u/LZj7v6NFpjtJfjoPMesVWICBpVfimuJM
 lcPyYFUo1mhY/REbwr/Dg==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:LKCZQM7MLW8=:19RYTE9K0M0kSLGw8X71Q/
 cazMFgS0IFR4s/dHFsl1CUFvYFIrIg+ahB3qOlR1y/mngBDhhub3xjzNC6Y4mrpu9f14EUQ5j
 1MxPm+/aSzJmcJTFqqRKB7PoOqcEFkek7ezXt7GxWx0XAKs6hKgm8ZzcCre1wDj2WgcU2/nmf
 /lrVDoMjTvkrK5Cra9X7XZm2NAw/m6+RNkWQKANfLIEcslWuDsZwLCNQbh/sSsJirwz0MKKzx
 6z3CQyNnoK2zPnkCcgdDOOnFxTlxDRbHUJgI2KCT5uxRVWucLUePSLXlQoR4E+L9XmBL4EiaQ
 3/Udlvu5006RULgxxdH5QDAVTWoNdmKFbA+l/q2wo4M+2QeI2lIrUB0qEEVQPnofwcm+0n+UE
 kAPlD5AyCwpW2vf5i6OOTpPki8hDUZuYLKQGq94Bvoe112nKknRjYrLM0dfN5Cp9+G1V5Gi9z
 g6HaopvIvx2eY8fXeXFiucbK8FjIw8j8dkGWKWEzis4+L+3/upvEZJzBB4LRKz7eDkvwkXJvW
 fF+fhUtYtTwBswGQayhwtHqjMXyFBcbKDb0yehhnPyNaA9VqHrI39mZfoYmeRtEUaPDuCUIGq
 YFhdTJQw8afAMRnI5zEg9q/AF8m0MYOjODpZ3SgOPyiQalMGhINzuYoEgAwPZfpwa7QVJfpDZ
 5biTWKuU5nW5OEU9n5RLQfNBK87ms/fTNofY0Anf6tb4maVqp4LWy3U9qXh4840vnRBZ2c83z
 URjvBazvEx/e1Y4yVOqidzzIjkzvf3oBaVXk7TaYl70XJFbjb80uo9BkOb6PlMP52g1/Klekv
 WbTxu6AmnRsa7WjLoo1SY20FaP4f2n0Odw9tZ/C92G0DyHvMzxR8KwAqkdaEPJeBoZbwg1FM8
 CBD3qFOsGgKZgFvq0F9pywMC4ebNREHRga5LIcGeDbVzUGmA6iyoQ3oLZeqgbtV/UzKttjMAn
 dwK5K4CEIlLwBaZe5RPj1HoESCz7jMUA=
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47207
Cc: acm@HIDDEN, 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

  and developers don't care.>> Because in my crash scenario (other-window 1 t) selects the tooltip
 >> window.
 >
 > OK, then solving this issue will solve that as well, I guess.

Having just managed to "solve this issue" here in a more or less elegant
way, Alan beat me to it with a new twist.  To reproduce with emacs -Q do

(custom-set-variables
  '(tooltip-reuse-hidden-frame t)
  '(x-gtk-use-system-tooltips nil))

show a tooltip (by moving the mouse over the mode line for example) and
then type C-h f followed by C-g.  Here this gets me

Thread 1 "emacs" hit Breakpoint 1, terminate_due_to_signal (sig=6, backtrace_limit=2147483647) at ../../src/emacs.c:399
399	  signal (sig, SIG_DFL);
(gdb) bt
#0  0x00000000005a6c28 in terminate_due_to_signal (sig=6, backtrace_limit=2147483647) at ../../src/emacs.c:399
#1  0x0000000000653420 in die (msg=0x7d01d6 "WINDOWP (a)", file=0x7d01c3 "../../src/window.h", line=543) at ../../src/alloc.c:7420
#2  0x00000000006006d2 in XWINDOW (a=XIL(0)) at ../../src/window.h:543
#3  0x00000000006039ae in read_minibuf_unwind () at ../../src/minibuf.c:1060
#4  0x000000000068e80e in do_one_unbind (this_binding=0x7fffffffc880, unwinding=true, bindflag=SET_INTERNAL_UNBIND) at ../../src/eval.c:3594
#5  0x000000000068ebc9 in unbind_to (count=3, value=XIL(0)) at ../../src/eval.c:3717
#6  0x00000000006877a5 in unwind_to_catch (catch=0xd99a40, type=NONLOCAL_EXIT_SIGNAL, value=XIL(0x2eb09c3)) at ../../src/eval.c:1254
#7  0x0000000000688dda in signal_or_quit (error_symbol=XIL(0xb5e0), data=XIL(0), keyboard_quit=true) at ../../src/eval.c:1784
#8  0x00000000006888df in quit () at ../../src/eval.c:1664
#9  0x00000000005ad8c5 in recursive_edit_1 () at ../../src/keyboard.c:722
#10 0x0000000000602e27 in read_minibuf (map=XIL(0x7ffff409d9f3), initial=XIL(0), prompt=XIL(0x10b6304), expflag=false, histvar=XIL(0x9ae0), histpos=make_fixnum(0), defalt=XIL(0x7ffff437cb7c), allow_props=false, inherit_input_method=false) at ../../src/minibuf.c:871
#11 0x00000000006044a0 in Fread_from_minibuffer (prompt=XIL(0x10b6304), initial_contents=XIL(0), keymap=XIL(0x7ffff409d9f3), read=XIL(0), hist=XIL(0), default_value=XIL(0x7ffff437cb7c), inherit_input_method=XIL(0)) at ../../src/minibuf.c:1312
#12 0x000000000068ca11 in funcall_subr (subr=0xc54d00 <Sread_from_minibuffer>, numargs=7, args=0x7fffffffcd70) at ../../src/eval.c:3011
#13 0x000000000068c36c in Ffuncall (nargs=8, args=0x7fffffffcd68) at ../../src/eval.c:2918
#14 0x00000000006e6056 in exec_byte_code (bytestr=XIL(0x7ffff409e1d4), vector=XIL(0x7ffff3cc1d4d), maxdepth=make_fixnum(18), args_template=make_fixnum(2050), nargs=8, args=0x7fffffffd308) at ../../src/bytecode.c:632
#15 0x000000000068cb24 in fetch_and_exec_byte_code (fun=XIL(0x7ffff3cc1d1d), syms_left=make_fixnum(2050), nargs=8, args=0x7fffffffd2c8) at ../../src/eval.c:3040
#16 0x000000000068cfaa in funcall_lambda (fun=XIL(0x7ffff3cc1d1d), nargs=8, arg_vector=0x7fffffffd2c8) at ../../src/eval.c:3121
#17 0x000000000068c3b0 in Ffuncall (nargs=9, args=0x7fffffffd2c0) at ../../src/eval.c:2920
#18 0x000000000060630a in Fcompleting_read (prompt=XIL(0x10b6304), collection=XIL(0x39a2e0), predicate=XIL(0x10bc4ed), require_match=XIL(0x30), initial_input=XIL(0), hist=XIL(0), def=XIL(0x7ffff437cb7c), inherit_input_method=XIL(0)) at ../../src/minibuf.c:2030
#19 0x000000000068ca75 in funcall_subr (subr=0xc54f00 <Scompleting_read>, numargs=7, args=0x7fffffffd448) at ../../src/eval.c:3016
#20 0x000000000068c36c in Ffuncall (nargs=8, args=0x7fffffffd440) at ../../src/eval.c:2918
#21 0x00000000006e6056 in exec_byte_code (bytestr=XIL(0x2ea3994), vector=XIL(0x10bc51d), maxdepth=make_fixnum(10), args_template=XIL(0), nargs=0, args=0x0) at ../../src/bytecode.c:632
#22 0x00000000006e5336 in Fbyte_code (bytestr=XIL(0x2ea3994), vector=XIL(0x10bc51d), maxdepth=make_fixnum(10)) at ../../src/bytecode.c:334
#23 0x000000000068ac71 in eval_sub (form=XIL(0x2ea7223)) at ../../src/eval.c:2401
#24 0x000000000068a1a8 in Feval (form=XIL(0x2ea7223), lexical=XIL(0)) at ../../src/eval.c:2224
#25 0x000000000068089d in Fcall_interactively (function=XIL(0x7ffff3057730), record_flag=XIL(0), keys=XIL(0x7ffff4373cbd)) at ../../src/callint.c:334
#26 0x000000000068c8ef in funcall_subr (subr=0xc5a140 <Scall_interactively>, numargs=3, args=0x7fffffffdd40) at ../../src/eval.c:2996
#27 0x000000000068c36c in Ffuncall (nargs=4, args=0x7fffffffdd38) at ../../src/eval.c:2918
#28 0x00000000006e6056 in exec_byte_code (bytestr=XIL(0x7ffff3d6b42c), vector=XIL(0x7ffff3d6ad45), maxdepth=make_fixnum(13), args_template=make_fixnum(1025), nargs=1, args=0x7fffffffe2b0) at ../../src/bytecode.c:632
#29 0x000000000068cb24 in fetch_and_exec_byte_code (fun=XIL(0x7ffff3d6ad15), syms_left=make_fixnum(1025), nargs=1, args=0x7fffffffe2a8) at ../../src/eval.c:3040
#30 0x000000000068cfaa in funcall_lambda (fun=XIL(0x7ffff3d6ad15), nargs=1, arg_vector=0x7fffffffe2a8) at ../../src/eval.c:3121
#31 0x000000000068c3b0 in Ffuncall (nargs=2, args=0x7fffffffe2a0) at ../../src/eval.c:2920
#32 0x000000000068bc9c in call1 (fn=XIL(0x4260), arg1=XIL(0x7ffff3057730)) at ../../src/eval.c:2778
#33 0x00000000005af009 in command_loop_1 () at ../../src/keyboard.c:1466
#34 0x00000000006881c8 in internal_condition_case (bfun=0x5ae7b0 <command_loop_1>, handlers=XIL(0x90), hfun=0x5addbf <cmd_error>) at ../../src/eval.c:1443
#35 0x00000000005ae395 in command_loop_2 (ignore=XIL(0)) at ../../src/keyboard.c:1094
#36 0x00000000006875d4 in internal_catch (tag=XIL(0xd7d0), func=0x5ae368 <command_loop_2>, arg=XIL(0)) at ../../src/eval.c:1193
#37 0x00000000005ae333 in command_loop () at ../../src/keyboard.c:1073
#38 0x00000000005ad8a6 in recursive_edit_1 () at ../../src/keyboard.c:720
#39 0x00000000005ada9e in Frecursive_edit () at ../../src/keyboard.c:789
#40 0x00000000005a9975 in main (argc=1, argv=0x7fffffffe7c8) at ../../src/emacs.c:2252

Lisp Backtrace:
"read-from-minibuffer" (0xffffcd70)
"completing-read-default" (0xffffd2c8)
"completing-read" (0xffffd448)
"byte-code" (0xffffd8a0)
"call-interactively" (0xffffdd40)
"command-execute" (0xffffe2a8)
(gdb)

I can easily sidestep this in read_minibuf_unwind via

   FOR_EACH_FRAME (frames, exp_MB_frame)
     {
       f = XFRAME (exp_MB_frame);
       if (!FRAME_TOOLTIP_P (f))
	{
	  window = f->minibuffer_window;
	  w = XWINDOW (window);
	  if (EQ (w->frame, exp_MB_frame)
	      && EQ (w->contents, nth_minibuffer (minibuf_level)))
	    goto found;
	}
     }

but the underlying issue remains: Not every frame has a minibuffer
window.

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 18 Mar 2021 16:49:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Mar 18 12:49:28 2021
Received: from localhost ([127.0.0.1]:47888 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lMvpv-00035x-Qx
	for submit <at> debbugs.gnu.org; Thu, 18 Mar 2021 12:49:28 -0400
Received: from eggs.gnu.org ([209.51.188.92]:44028)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lMvpu-00035j-CQ
 for 47207 <at> debbugs.gnu.org; Thu, 18 Mar 2021 12:49:26 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:59114)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lMvpn-0007rL-OP; Thu, 18 Mar 2021 12:49:19 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3923
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lMvpj-0001Qo-W5; Thu, 18 Mar 2021 12:49:17 -0400
Date: Thu, 18 Mar 2021 18:49:17 +0200
Message-Id: <83r1kcflv6.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
In-Reply-To: <11b795a6-1a20-cc58-73d6-b75227dc732a@HIDDEN> (message from
 martin rudalics on Thu, 18 Mar 2021 16:51:18 +0100)
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
References: <c8442033-ac9b-f9e0-d5f5-3d649a874c3f@HIDDEN>
 <83r1kddi2r.fsf@HIDDEN> <37300876-70d1-c741-8a4d-97d024fdf6cf@HIDDEN>
 <83k0q5dbml.fsf@HIDDEN> <64dca5b5-1234-9176-dcfe-b42d6eea2caa@HIDDEN>
 <83h7l9d651.fsf@HIDDEN> <ea56065e-eccc-b6fe-e1ba-671f8352986d@HIDDEN>
 <83eegdd4uz.fsf@HIDDEN> <ded69182-aa24-2939-aa9a-ec61889052a1@HIDDEN>
 <8335wsdcob.fsf@HIDDEN> <11b795a6-1a20-cc58-73d6-b75227dc732a@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47207
Cc: acm@HIDDEN, 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> Cc: 47207 <at> debbugs.gnu.org, acm@HIDDEN
> From: martin rudalics <rudalics@HIDDEN>
> Date: Thu, 18 Mar 2021 16:51:18 +0100
> 
>  >> ... but we don't even have `window-tooltip-p' yet.
>  >
>  > It's a one-liner, isn't it?  I'm not even sure we need a function for
>  > that, but I won't object adding one.
> 
> What would you do instead?

  (frame-parameter FRAME 'tooltip)

>  >> Why did you decline the proposal to expose buffer markers to Elisp?
>  >
>  > How is that relevant to the present discussion?
>  >
>  >>   > That those who do it must know what they are
>  >>   > doing is a truism; restricting legitimate uses for fear of
>  >>   > illegitimate ones is punishing the innocent for fear of the evil --
>  >>   > that's the problem with TSA, for example.
> 
> I don't know what TSA is and its relevance to Emacs.  But when Basil
> proposed to add a function called `marker-list' you answered
> 
>    Just reading the markers probably won't but do you really believe this
>    is the last word?  How many hours will it take for someone to ask for
>    a primitive to set the C-level markers as well, or request the ability
>    to map a function over all the markers?  If it's really needed, sure,
>    let's do it.  But is it?  Or are we doing that just because we can?
> 
> which ended up with Bug#35536 marked as wontifx.  For me this is a
> classic example of "punishing the innocent for fear of the evil".

The above was about _adding_ an interface.  By contrast, here we are
talking about an interface that existed for eons.  That makes the
world of difference for me.

>  >> We still have no concept for whether and where we would refuse
>  >> selecting a tooltip window - in `select-window', select_window,
>  >> `select-frame', wherever we set selected_window ...
>  >
>  > Then let's develop that concept.  But again, how is this relevant to
>  > the issue at hand?
> 
> Because in my crash scenario (other-window 1 t) selects the tooltip
> window.

OK, then solving this issue will solve that as well, I guess.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 18 Mar 2021 15:51:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Mar 18 11:51:31 2021
Received: from localhost ([127.0.0.1]:47810 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lMuvr-0001b9-F4
	for submit <at> debbugs.gnu.org; Thu, 18 Mar 2021 11:51:31 -0400
Received: from mout.gmx.net ([212.227.15.19]:48489)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1lMuvp-0001av-K4
 for 47207 <at> debbugs.gnu.org; Thu, 18 Mar 2021 11:51:30 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1616082681;
 bh=WYXRMdEGVNaaQXKYiImtJFNyd+hCvyX7iaaIk3ysL1k=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=XV0sZJ50b9ctoHPaktW5tWvBc5SWgEeUSh5TsSNTjnAzqJ77s3ZieFjoaAtJGfWm3
 D4WGHJuKAq2KJ0DgvPQZ/SdX5M2BS7V/rlN4CWCKUlKGRN5AYISx6qYD11VYufA52r
 pU+5iEg/gWZvnauhXJFw+Fijy/lSTsAja3ZGMDHw=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.21]) by mail.gmx.net (mrgmx005
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1McH9i-1lzYX70GLs-00ceaf; Thu, 18
 Mar 2021 16:51:21 +0100
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
To: Eli Zaretskii <eliz@HIDDEN>
References: <c8442033-ac9b-f9e0-d5f5-3d649a874c3f@HIDDEN>
 <83r1kddi2r.fsf@HIDDEN> <37300876-70d1-c741-8a4d-97d024fdf6cf@HIDDEN>
 <83k0q5dbml.fsf@HIDDEN> <64dca5b5-1234-9176-dcfe-b42d6eea2caa@HIDDEN>
 <83h7l9d651.fsf@HIDDEN> <ea56065e-eccc-b6fe-e1ba-671f8352986d@HIDDEN>
 <83eegdd4uz.fsf@HIDDEN> <ded69182-aa24-2939-aa9a-ec61889052a1@HIDDEN>
 <8335wsdcob.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <11b795a6-1a20-cc58-73d6-b75227dc732a@HIDDEN>
Date: Thu, 18 Mar 2021 16:51:18 +0100
MIME-Version: 1.0
In-Reply-To: <8335wsdcob.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:LVE2d6oztHS2khCh2cLxRcrfVfXovxkCtA8D7cI33rpKtPt7WAn
 j03FWGu63qU5URVpMmOQsWcvoX5yTMqEn52yL4iSGrzG1NZLYrFcYWukiZn5tVtRCte8YMU
 w+vuQwRIUtDliXungW8VCZSSfiRRDqpe+3lZGl5X+uXsHYtuNEWqIylUclbkzVj4AxHSHoK
 4a5GrBXlRpbRLrg2Xka7A==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:1GbWDtJbJT4=:CnqC4/SZG5Nd2a1+qsQpCi
 cOybVQhxXRC/D8ioPUKiGPSCLQQUgCwkAXXt2ZtZ+ULa8R7R2R3vB25CBHfC2+PmfmgpZxoEn
 qw3AdwefHB+LAmE2dgT69ew1uZn3lJSLe9pl+7env060WA5LAwhy4kVdPnWc8Y0zcrI8ByUBv
 1ogpUMW2IKEn4N+1UsCWJ6fkHMDAjva0k/teRQr00VZ+4SAZBRHIyDSllo/L17a+D/JF0iPoW
 3MJ1x1Z2eE6oavTwWZzSC3wm2zbrt05DePuZGQMZDAN5Qgzu0mV5l8uj7nxG5WRhNrGivTSe3
 RtKx21DZuDemDnOWFACsFGPXw52UDP0whSGXVCyE0f+Tys223ImPdl1QQCwPIDhbCjQKSNsvU
 tmBUKH5LepxCf7ztsNhIpp2iJHoynI54CIU55QkegF/Wzl+9BX58ACO1XAb0B5du4nIl/FVzD
 9DNHlr4weGxP2H6pT+A8Vau1f+fGfH75AC6ZAYjlBUUlB3jdSsOuhOPv9/mjHfjpdmTuI4w5b
 o7zvBQpsB+dwW8JA/TA+H3zXnz/fhdWj52BqByq6VLLgtIzHLCVB8XNFqKsZuXGb0iSQM1HeX
 6+FEDdgp7IR7gKljOaQneuGYgPGG21An6bfGpecX17t4HUQ5tNk6A/kdbRsnYkwnp8MVXRbMM
 eWvHjB9rnsHLLmHlD0H2l1GJrkio/xZsJClL1sBdFgh08nW7hPPNf64BpXGZkp73wCoBvnrGC
 U8egsfSs6Zhk/ZMlfiblTeB5MoyBG5ktPiH+8qS7l5P8phJkle7StBqRr5uBzYB116LRwDHP2
 85JsMloLWcAo0ygYAhcURF0bYMFnbVGkoEsSDZbvygQgC1IvwzwzBrEIP/xKdbrLzc9rqMW6n
 xLq3uvrHtXWtLC7sTH7Q==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47207
Cc: acm@HIDDEN, 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 >> ... but we don't even have `window-tooltip-p' yet.
 >
 > It's a one-liner, isn't it?  I'm not even sure we need a function for
 > that, but I won't object adding one.

What would you do instead?

 >> Why did you decline the proposal to expose buffer markers to Elisp?
 >
 > How is that relevant to the present discussion?
 >
 >>   > That those who do it must know what they are
 >>   > doing is a truism; restricting legitimate uses for fear of
 >>   > illegitimate ones is punishing the innocent for fear of the evil --
 >>   > that's the problem with TSA, for example.

I don't know what TSA is and its relevance to Emacs.  But when Basil
proposed to add a function called `marker-list' you answered

   Just reading the markers probably won't but do you really believe this
   is the last word?  How many hours will it take for someone to ask for
   a primitive to set the C-level markers as well, or request the ability
   to map a function over all the markers?  If it's really needed, sure,
   let's do it.  But is it?  Or are we doing that just because we can?

which ended up with Bug#35536 marked as wontifx.  For me this is a
classic example of "punishing the innocent for fear of the evil".

 >> We still have no concept for whether and where we would refuse
 >> selecting a tooltip window - in `select-window', select_window,
 >> `select-frame', wherever we set selected_window ...
 >
 > Then let's develop that concept.  But again, how is this relevant to
 > the issue at hand?

Because in my crash scenario (other-window 1 t) selects the tooltip
window.

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 18 Mar 2021 09:38:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Mar 18 05:38:42 2021
Received: from localhost ([127.0.0.1]:45079 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lMp74-0003zp-8D
	for submit <at> debbugs.gnu.org; Thu, 18 Mar 2021 05:38:42 -0400
Received: from eggs.gnu.org ([209.51.188.92]:47664)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lMp70-0003zb-0w
 for 47207 <at> debbugs.gnu.org; Thu, 18 Mar 2021 05:38:41 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:51739)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lMp6t-0007PK-12; Thu, 18 Mar 2021 05:38:32 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4734
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lMp6r-0005As-Um; Thu, 18 Mar 2021 05:38:30 -0400
Date: Thu, 18 Mar 2021 11:38:28 +0200
Message-Id: <8335wsdcob.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
In-Reply-To: <ded69182-aa24-2939-aa9a-ec61889052a1@HIDDEN> (message from
 martin rudalics on Thu, 18 Mar 2021 09:43:57 +0100)
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
References: <c8442033-ac9b-f9e0-d5f5-3d649a874c3f@HIDDEN>
 <83r1kddi2r.fsf@HIDDEN> <37300876-70d1-c741-8a4d-97d024fdf6cf@HIDDEN>
 <83k0q5dbml.fsf@HIDDEN> <64dca5b5-1234-9176-dcfe-b42d6eea2caa@HIDDEN>
 <83h7l9d651.fsf@HIDDEN> <ea56065e-eccc-b6fe-e1ba-671f8352986d@HIDDEN>
 <83eegdd4uz.fsf@HIDDEN> <ded69182-aa24-2939-aa9a-ec61889052a1@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47207
Cc: acm@HIDDEN, 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> Cc: 47207 <at> debbugs.gnu.org, acm@HIDDEN
> From: martin rudalics <rudalics@HIDDEN>
> Date: Thu, 18 Mar 2021 09:43:57 +0100
> 
>  > I don't think I understand what's bothering you.  The idea is simple:
>  > if you get a frame that's a tooltip frame, ask for another one.
> 
> Like the below, I suppose.

Something like that, yes.

> ... but we don't even have `window-tooltip-p' yet.

It's a one-liner, isn't it?  I'm not even sure we need a function for
that, but I won't object adding one.

>  >> Checking whether the returned frame is a tooltip frame in
>  >> `next-window-any-frame' means any Lisp code that does not do
>  >> something similar can crash Emacs.
>  >
>  > Crash how?
> 
> As in my report.  These were the only times I've been losing Emacs
> sessions in the past years.

If we didn't fix that yet, let's fix it ASAP.

>  > In any case, the idea that something applications might forget to do
>  > would mean we must push the checks to lower levels sounds wrong to me.
>  > Lower levels should be free from application-level constraints, so
>  > that if someone wants to write code which breaks those constraints,
>  > he/she could do that.
> 
> Why did you decline the proposal to expose buffer markers to Elisp?

How is that relevant to the present discussion?

>  > That those who do it must know what they are
>  > doing is a truism; restricting legitimate uses for fear of
>  > illegitimate ones is punishing the innocent for fear of the evil --
>  > that's the problem with TSA, for example.
> 
> We still have no concept for whether and where we would refuse
> selecting a tooltip window - in `select-window', select_window,
> `select-frame', wherever we set selected_window ...

Then let's develop that concept.  But again, how is this relevant to
the issue at hand?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 18 Mar 2021 08:44:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Mar 18 04:44:14 2021
Received: from localhost ([127.0.0.1]:44981 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lMoGM-0002cs-0D
	for submit <at> debbugs.gnu.org; Thu, 18 Mar 2021 04:44:14 -0400
Received: from mout.gmx.net ([212.227.17.22]:49987)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1lMoGH-0002cK-Na
 for 47207 <at> debbugs.gnu.org; Thu, 18 Mar 2021 04:44:12 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1616057040;
 bh=s0P74VKdwYLRPPO/fI1JAysho7WTho3RTapYI2DgIrE=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=XeQYwJIIlOVLlXjJd69oz03g5EDG56dgjkmcNYmKFTtQs/wvAWp5nd2OlUnY/pQVq
 WR0MxKyDX+077MaDPkNxD0TnhcdCGtdwyCUtYxLY+X+g8NiHLe3T4CZ9BtpmeErxto
 9vqPdIUOh57UeZAolMiflRvf+siQHP1bnmmqBAng=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([46.125.249.16]) by mail.gmx.net (mrgmx104
 [212.227.17.168]) with ESMTPSA (Nemesis) id 1MrQJ5-1m0q7M3EyF-00oWkM; Thu, 18
 Mar 2021 09:43:59 +0100
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
To: Eli Zaretskii <eliz@HIDDEN>
References: <c8442033-ac9b-f9e0-d5f5-3d649a874c3f@HIDDEN>
 <83r1kddi2r.fsf@HIDDEN> <37300876-70d1-c741-8a4d-97d024fdf6cf@HIDDEN>
 <83k0q5dbml.fsf@HIDDEN> <64dca5b5-1234-9176-dcfe-b42d6eea2caa@HIDDEN>
 <83h7l9d651.fsf@HIDDEN> <ea56065e-eccc-b6fe-e1ba-671f8352986d@HIDDEN>
 <83eegdd4uz.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <ded69182-aa24-2939-aa9a-ec61889052a1@HIDDEN>
Date: Thu, 18 Mar 2021 09:43:57 +0100
MIME-Version: 1.0
In-Reply-To: <83eegdd4uz.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:W1RcfMiVmNXqCpY7QzEPeZ4ILVjtxuV+7sfW8XpnlTS0RrB0CJJ
 HOSZZQmqf93E2JVA4H5WZJfSVE4xnUuyn0+OYxiiznLKZUuwUyESN3GqPLrSUcZGQWVFB5o
 RcN6dR4Y/05N0zqA4F5hQcCos+rjvDqJT1Uz4fkZOwFdv4arohrxv3LqjUuLw/VufgeUfyk
 DpVhtyd2SNbLPswypMULg==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:4ADhOGG2M3Y=:4oqYFdxPNSpYYz7hU/ibhK
 RBcqrW/uTFxjncUmEKJn71PKuGah8M2KTzLbhWo8bttN5/P7proFfuVHQb+zF9plAl/HLt1tF
 /i3Owk1MJyGsQkX/EclnW7orSpy0wTcKDdsKT6gdmxNICUAaF4qRp5BNdQjagfW2jMMIADit3
 zCd7nDoOYBCDGaFqRVJCBmR5RJo8zig7lzI2BB8sO/sJK9aUvt+OIYEE2ibkSH80uru0AZCF1
 eE/yaU0+EEluWoqdqC9pngGbYMsaNMUdlQgDmCRguqYfwSnmHJ59cBH8f62yHXNYL8/rxNmXZ
 K+U/w6PGfvYWqIszOKO/1uA7yhRscetWtttlinjwyCsiko4Jmaj9z+UwplhD5SVu3che5Amf8
 qZFuF7r7ByFBgimu7wuTEY+R+S9rYjTnI+ImbQy30n4CVNjdoWPFZzJxphjcWdztYtjhevIGP
 aRqVEBiPLh+zPW+2EMCXNdROt2Qy95CK1vCnJEA52Trz/27eFNB/1OEFFxGn7Ha4BOErzRi5Q
 7pZKcO1Afhxl02XbVOG3NB5uOiU88deHdrVaRfu875R9s9/knV31nBlm7lSAL5UaUpf6qN0FH
 6gF5s9Bh22jriqqRIUJBXUYBmEiATKXlynjifjH38kbsfpHRZWHYYYFW+3m4B/1tJVEl5wQUX
 9Pczp3sRDZuDwrQhNgJWHb18lq5/R78DRQWFO0e/OBaDY8NcAF9Jgt+hMoHeAqJgJDs89nDST
 SgEn4GmchxXOvnDMXFDLD346t3crrQEeExnCdtwZU8xWtLl7Kp76lvk+68oyxqUy63VA4u0dw
 3jRQPn6rEtjwhvPwW134TZv43QuT2LRcvjNiTa1uRwxwz+vqR7Z+f88hqfUCfM3WuapXgQhSi
 zyV25cFlxB0Ackw3lbHw==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47207
Cc: acm@HIDDEN, 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 >>   >> How would we handle that suggestion in say `next-window-any-frame'?
 >>   >
 >>   > Skip tooltip frames, I guess.
 >>
 >> But how if we don't want to do it in `next-frame'?
 >
 > I don't think I understand what's bothering you.  The idea is simple:
 > if you get a frame that's a tooltip frame, ask for another one.

Like the below, I suppose.  The idea is simple ...

(defun next-window-any-frame ()
   "Select the next window, regardless of which frame it is on."
   (interactive)
   (catch 'failed
     (let ((selected (selected-window))
	  (next (next-window nil nil 0)))
       (while (window-tooltip-p next)
	(setq next (next-window next nil 0))
	(when (eq next selected)
	  (throw 'failed nil)))

       (select-window next)
       (select-frame-set-input-focus (selected-frame)))))

... but we don't even have `window-tooltip-p' yet.

 >> Checking whether the returned frame is a tooltip frame in
 >> `next-window-any-frame' means any Lisp code that does not do
 >> something similar can crash Emacs.
 >
 > Crash how?

As in my report.  These were the only times I've been losing Emacs
sessions in the past years.

 > In any case, the idea that something applications might forget to do
 > would mean we must push the checks to lower levels sounds wrong to me.
 > Lower levels should be free from application-level constraints, so
 > that if someone wants to write code which breaks those constraints,
 > he/she could do that.

Why did you decline the proposal to expose buffer markers to Elisp?

 > That those who do it must know what they are
 > doing is a truism; restricting legitimate uses for fear of
 > illegitimate ones is punishing the innocent for fear of the evil --
 > that's the problem with TSA, for example.

We still have no concept for whether and where we would refuse
selecting a tooltip window - in `select-window', select_window,
`select-frame', wherever we set selected_window ...

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 17 Mar 2021 18:15:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Mar 17 14:15:14 2021
Received: from localhost ([127.0.0.1]:43960 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lMahO-00061t-6p
	for submit <at> debbugs.gnu.org; Wed, 17 Mar 2021 14:15:14 -0400
Received: from eggs.gnu.org ([209.51.188.92]:40774)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lMahL-00061c-Tz
 for 47207 <at> debbugs.gnu.org; Wed, 17 Mar 2021 14:15:13 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:40882)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lMahF-0001Pa-1n; Wed, 17 Mar 2021 14:15:05 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3737
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lMahD-0001vC-Kq; Wed, 17 Mar 2021 14:15:04 -0400
Date: Wed, 17 Mar 2021 20:15:00 +0200
Message-Id: <83eegdd4uz.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
In-Reply-To: <ea56065e-eccc-b6fe-e1ba-671f8352986d@HIDDEN> (message from
 martin rudalics on Wed, 17 Mar 2021 19:01:26 +0100)
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
References: <c8442033-ac9b-f9e0-d5f5-3d649a874c3f@HIDDEN>
 <83r1kddi2r.fsf@HIDDEN> <37300876-70d1-c741-8a4d-97d024fdf6cf@HIDDEN>
 <83k0q5dbml.fsf@HIDDEN> <64dca5b5-1234-9176-dcfe-b42d6eea2caa@HIDDEN>
 <83h7l9d651.fsf@HIDDEN> <ea56065e-eccc-b6fe-e1ba-671f8352986d@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47207
Cc: acm@HIDDEN, 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> Cc: 47207 <at> debbugs.gnu.org, acm@HIDDEN
> From: martin rudalics <rudalics@HIDDEN>
> Date: Wed, 17 Mar 2021 19:01:26 +0100
> 
>  >> How would we handle that suggestion in say `next-window-any-frame'?
>  >
>  > Skip tooltip frames, I guess.
> 
> But how if we don't want to do it in `next-frame'?

I don't think I understand what's bothering you.  The idea is simple:
if you get a frame that's a tooltip frame, ask for another one.

> Checking whether the returned frame is a tooltip frame in
> `next-window-any-frame' means any Lisp code that does not do
> something similar can crash Emacs.

Crash how?

In any case, the idea that something applications might forget to do
would mean we must push the checks to lower levels sounds wrong to me.
Lower levels should be free from application-level constraints, so
that if someone wants to write code which breaks those constraints,
he/she could do that.  That those who do it must know what they are
doing is a truism; restricting legitimate uses for fear of
illegitimate ones is punishing the innocent for fear of the evil --
that's the problem with TSA, for example.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 17 Mar 2021 18:01:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Mar 17 14:01:39 2021
Received: from localhost ([127.0.0.1]:43949 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lMaUF-0005i9-Fy
	for submit <at> debbugs.gnu.org; Wed, 17 Mar 2021 14:01:39 -0400
Received: from mout.gmx.net ([212.227.17.20]:52499)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1lMaUC-0005hv-Uf
 for 47207 <at> debbugs.gnu.org; Wed, 17 Mar 2021 14:01:38 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1616004089;
 bh=NRo8tOD6bIEyJh4GpaC+k7IT4MN0JFkcDuuqbq87uTY=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=gSkJOsSGY3w4nbCmPuClKLoOXvb+/TpvaJaT3WYsgW40YIC8r27SIO8sPYPoQf5vZ
 BhJ5QGmCLaH3yqifiCgI8I3ivWyVFD2BtcsUU/Rcqn0R3G06NH78l2KjXMQPS+yP26
 8nPQ8yShaSbIQ6VKEBmic8kmPrlOzywXpVAoxipE=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([46.125.249.77]) by mail.gmx.net (mrgmx104
 [212.227.17.168]) with ESMTPSA (Nemesis) id 1Msq24-1lgSkS2XHs-00tCXW; Wed, 17
 Mar 2021 19:01:28 +0100
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
To: Eli Zaretskii <eliz@HIDDEN>
References: <c8442033-ac9b-f9e0-d5f5-3d649a874c3f@HIDDEN>
 <83r1kddi2r.fsf@HIDDEN> <37300876-70d1-c741-8a4d-97d024fdf6cf@HIDDEN>
 <83k0q5dbml.fsf@HIDDEN> <64dca5b5-1234-9176-dcfe-b42d6eea2caa@HIDDEN>
 <83h7l9d651.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <ea56065e-eccc-b6fe-e1ba-671f8352986d@HIDDEN>
Date: Wed, 17 Mar 2021 19:01:26 +0100
MIME-Version: 1.0
In-Reply-To: <83h7l9d651.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:y6cdK4ZnaJnqwMgkOrgBlpkwEjxTc0H4nGL0zdlBfPtPJJkevHR
 H5fvJH/4XqxNWSyY+8vZydBETMQh1jnbqkifor9i8154bgpObPPihJ9UgIrMc5/36zGidLa
 z0S9Lu2Xt4AGnOvgf7mKh616fZN3RdqOEv/l3KpL/lp7AV0Efd3iPnoBBOFbQSJqyfdbZDG
 VwU7xQOcDEMDppSiQ9+/g==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:Cn5HUZpYQuY=:z8xwl2ZMU3GvMmXFDrdblc
 +9L4/tUOO5pSj7ihSPJDgBbrUIGXtcvFngKc6PBU397lG4MCAb7EmRVBnQSm6Vm6d5pFtb2yP
 gvKT717NqAKg1fH5pZdiI/31OIxgQ2eWUCBgXw1OfCD1f+WO+jTDWdjmmGbM+ntm3gNeUEZGH
 PJOemjB1aokkImBzYhuonKJAyFsiiL1S/J5hOapTRQ8wgGrsVpZvUhO3gBHAM3b2U/Lfb8OuW
 pcksII6AxXbwq71D3SERvlvxX/Ehbk1lTTvnLIf23q0MUiwE/kwN0ccxYQsksoCRiDiLYJdYg
 wGVWr4XKA9hudLuIwY+3xS82mSCZFAmh5yndUaxqLMe3jfd7nBPPluOnPs4yQ14ntQkoxI6qw
 0eChleE3wjKIENO1Nougb0l+vV4Q82dSyUSMciOLo2+pCbeji2YOoChCveVlA5ZIQjXUKazGS
 tgvIPcDuaqHosNMH5oX3zguwOxMl9RluArQAfmL7lN4K5FJd3XJ+Ahuj53PoFImL3FiwUO2b4
 m9FdO0gFq8ZvIpNVTh66RT2Zg1B/zhqT6KcQ5R86GDVR+9JlCh1zj3cpvKXVv89YJ02o5mV1L
 zG9jVH9XBcJ2hW461RMOJfmHe1t0qLOIYs4qtZKbS4mtURT5QKHq7WFBp8d8aUst3UVZQtHHj
 E2Z7x5Y6vEn8CgltoCZG0cyHnZEHt8NPf0C8JgFyodvbjg1T2K5oVh4OlAv+uJUsFHIKHTPP8
 Oc0YFM7PHXP4Oft+/wqjqPjwFEKRcLy7UaSFxsvvXceJ030XURDb4k9GPWYAS7ZrHCf4rlvXr
 qDRGzaC6vUVkMohnTDYXDHi2PX+XA3NzNxOarNnyBrpyBeWSmgmmkWcRjFdxsdZ6kxIsplVkx
 UYhOCWtXn3PuzlYQmWa2D5EwbTp5pQvuuNoNGqUa8llEeucA3pRoBbJZbxo3TNJlL6yPSMAke
 9RwqZBY//GJ2KO5/B0PKjJg5pQ/Sn7INIBZDGDeKXasU18TQV+UvUXxL6nIBkv4uU+MPyYpU4
 9GnCOW6cAOntbBsexE/14cqBB93Alt/xRC9unYOb0LNWDCmiwOuiM0omPQysScqUCqjmHtKAa
 I0Mjs/CLPAGjF9SCeuCBcXbU8R+m4pNi/tptT76mbcJObtMXte/9/Zb56cSER3J08KAKextgb
 /SZOK5OL5SeY5EE4vKRCU9kRqDSIQbG5fGFCzBdV0GaGjNQQDSkUtIsc0TB5aLeGaIzw4=
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47207
Cc: acm@HIDDEN, 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 >> How would we handle that suggestion in say `next-window-any-frame'?
 >
 > Skip tooltip frames, I guess.

But how if we don't want to do it in `next-frame'?  Throwing an error in
`select-window' here would be a strange thing for a user.  Checking
whether the returned frame is a tooltip frame in `next-window-any-frame'
means any Lisp code that does not do something similar can crash Emacs.

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 17 Mar 2021 17:47:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Mar 17 13:47:35 2021
Received: from localhost ([127.0.0.1]:43940 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lMaGc-0005MU-SN
	for submit <at> debbugs.gnu.org; Wed, 17 Mar 2021 13:47:35 -0400
Received: from eggs.gnu.org ([209.51.188.92]:32994)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lMaGZ-0005MF-Ct
 for 47207 <at> debbugs.gnu.org; Wed, 17 Mar 2021 13:47:33 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:40319)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lMaGT-0000j5-7k; Wed, 17 Mar 2021 13:47:25 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2049
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lMaGR-0005U4-OT; Wed, 17 Mar 2021 13:47:24 -0400
Date: Wed, 17 Mar 2021 19:47:22 +0200
Message-Id: <83h7l9d651.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
In-Reply-To: <64dca5b5-1234-9176-dcfe-b42d6eea2caa@HIDDEN> (message from
 martin rudalics on Wed, 17 Mar 2021 18:06:24 +0100)
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
References: <c8442033-ac9b-f9e0-d5f5-3d649a874c3f@HIDDEN>
 <83r1kddi2r.fsf@HIDDEN> <37300876-70d1-c741-8a4d-97d024fdf6cf@HIDDEN>
 <83k0q5dbml.fsf@HIDDEN> <64dca5b5-1234-9176-dcfe-b42d6eea2caa@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47207
Cc: acm@HIDDEN, 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> Cc: 47207 <at> debbugs.gnu.org, acm@HIDDEN
> From: martin rudalics <rudalics@HIDDEN>
> Date: Wed, 17 Mar 2021 18:06:24 +0100
> 
>  > That's about the selected-frame, and tooltip frames should never be
>  > selected.  Right?
> 
> How would we handle that suggestion in say `next-window-any-frame'?

Skip tooltip frames, I guess.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 17 Mar 2021 17:06:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Mar 17 13:06:38 2021
Received: from localhost ([127.0.0.1]:43898 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lMZd0-0004Nc-I9
	for submit <at> debbugs.gnu.org; Wed, 17 Mar 2021 13:06:38 -0400
Received: from mout.gmx.net ([212.227.15.19]:39189)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1lMZcv-0004NI-Tc
 for 47207 <at> debbugs.gnu.org; Wed, 17 Mar 2021 13:06:37 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1616000786;
 bh=iZc0EOx9iMDKOFv4qYJWqlMiqMoc4Q6a6RiCZWCEQko=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=XuWsqAUVj3T3IMD4heaiavceIpvCOresdKJeY65NcEPDtFNspc8zd7gXQQZURLdhF
 Ap5Mn5mA5oEqxR1Y/G177rU5lTRgJ11kIN+JQzHCDnLrf8gDzIdsXOdfQEndVMZQ/C
 byTRXXGXNa9I7X+NLwu842WNdnNPiSKfgdy/O3Gg=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([46.125.249.77]) by mail.gmx.net (mrgmx005
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1MWzfv-1lBsGx0dFx-00XNpA; Wed, 17
 Mar 2021 18:06:26 +0100
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
To: Eli Zaretskii <eliz@HIDDEN>
References: <c8442033-ac9b-f9e0-d5f5-3d649a874c3f@HIDDEN>
 <83r1kddi2r.fsf@HIDDEN> <37300876-70d1-c741-8a4d-97d024fdf6cf@HIDDEN>
 <83k0q5dbml.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <64dca5b5-1234-9176-dcfe-b42d6eea2caa@HIDDEN>
Date: Wed, 17 Mar 2021 18:06:24 +0100
MIME-Version: 1.0
In-Reply-To: <83k0q5dbml.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:HMFRbyxzhBeas5sl0kQ9/nFW5vLtctqwTYlgg+p5775UEaFuc8H
 NFYlyXk2QL7GD4r/F40qwJtWRyJ6HruMtV9dyCA2w19gs1vIipAg+AhWkJtnoJxpgSJkBev
 CS0M0NXb4rqg0ylUxVHglCZoq1+Xs2AbsxywZLc3CzHLJkJZegIQU++lnGfsf7K2qVqPV6k
 mDKV2x7l9f7j1Q1L/Ssug==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:vwb4ip+c77g=:Ey+F8xTLJXDJVAfsc1keK6
 /ZiP7OeAk1A52R803J9ZRBk1HCk4jhVhX1foGrITU/cqhPXkI+guXZnZ15Sn3x/1yTtEnbj0M
 HDXipCC8JzOZC3byddqWTljPnDNi0u01xqajVOK2gT/Zt1rVjPLxBcN4OZLcfc6mak7wsK3kx
 JoDNCpxpwowk7GxN/AThtPr2AFaMTDRCj5c3rprHEIxExMHoKY6o87Av5d1fPrnKHQcnI0xSF
 ZB+8bFRvdEPVov7uP9jSHjWuWt1Hrp2jXcSC3XqhccjJSdTXhcBDGiUWZqgjPKMHQrLYgLnA6
 YcJhst/hyzxKj8C2QFKtew76khXjCzzR37J02vW4TrHqVd9KFE/GeGMO7EOny+SJGuMjfayhj
 YRJOHkK9F8t/VCVfzaDnITViYuGNZL2GxmW1hz+lnOQN1dmka9p/g5NH8r50Qh/l7A9G9+P7a
 qJfjO9QfCvtDn2yLBu/6qGh+aiFjFr2lTHCKmZqlcrxcT63n1xCnF6Rb6KFDuQ4WRsY8vz/uU
 Nx0gLpmo8b3a/yDfxjBO8+InrJwpXf0lKRxzGFwjFGJe5QSOwV6ZtDzPAKdZhuHKbTuvJmZmR
 NIn7JOCEbsEgxDAY7TxYGo/O9qAEzdGQZcbIW7OARVt6bFP2NX3MHu3rjwDM+HbhEisJsQHEo
 FbzEqs1jmPMQh1A5hsPzuHbEep/3RGqFMa4ufMHeWiFsGh5vaz0ixJ98PBIJhSujOga56mKjJ
 MUHZir7tGeG2zltnzSzULI5VlwV7Bucg2Y+2ACNxLvOMeNGsijvyFvkRwTUhHJ+23Ns2fIKCL
 sP32ORkia+ZQl895uxNl21iGd9AGdeSGa1fWwLHTGrZ1VEJhfgm+sATTN9I7bHPoeZ2bGxAw6
 /BilCE/+NE+/Sp2/yShw==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47207
Cc: acm@HIDDEN, 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 > But the alternative is IMO much worse: there will be _no_ way
 > whatsoever to reach those windows via next_window.

What would be bad about that?

 > The default is already not to consider those windows, so why it is a
 > problem that they are considered when the code explicitly requests to
 > consider _all_ the windows?
 >
 >> Think of minibuf.c's
 >>
 >>         struct frame *sf = XFRAME (selected_frame);
 >>         /* I don't think that any frames may validly have a null minibuffer
 >> 	 window anymore.  */
 >>         if (NILP (sf->minibuffer_window))
 >> 	emacs_abort ();
 >
 > That's about the selected-frame, and tooltip frames should never be
 > selected.  Right?

How would we handle that suggestion in say `next-window-any-frame'?

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 17 Mar 2021 15:49:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Mar 17 11:49:14 2021
Received: from localhost ([127.0.0.1]:43835 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lMYPv-0002Vb-3C
	for submit <at> debbugs.gnu.org; Wed, 17 Mar 2021 11:49:13 -0400
Received: from eggs.gnu.org ([209.51.188.92]:60178)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lMYPr-0002V5-P0
 for 47207 <at> debbugs.gnu.org; Wed, 17 Mar 2021 11:49:01 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:38293)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lMYPk-0006ar-9m; Wed, 17 Mar 2021 11:48:54 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2680
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lMYPj-0008B3-Lu; Wed, 17 Mar 2021 11:48:52 -0400
Date: Wed, 17 Mar 2021 17:48:50 +0200
Message-Id: <83k0q5dbml.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
In-Reply-To: <37300876-70d1-c741-8a4d-97d024fdf6cf@HIDDEN> (message from
 martin rudalics on Wed, 17 Mar 2021 16:36:53 +0100)
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
References: <c8442033-ac9b-f9e0-d5f5-3d649a874c3f@HIDDEN>
 <83r1kddi2r.fsf@HIDDEN> <37300876-70d1-c741-8a4d-97d024fdf6cf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47207
Cc: acm@HIDDEN, 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> Cc: 47207 <at> debbugs.gnu.org, acm@HIDDEN
> From: martin rudalics <rudalics@HIDDEN>
> Date: Wed, 17 Mar 2021 16:36:53 +0100
> 
>  >> we probably should decide whether to consider tooltip windows in
>  >> `next-window' or `other-window' at all.
>  >
>  > Not sure why.  Don't we envision some applications that would like to
>  > examine tooltip windows?  IOW, that tooltip frames don't have a
>  > minibuffer doesn't necessarily mean we don't want to give window
>  > iterations access to tooltip windows.
> 
> But then people must be always careful to never look into the minibuffer
> window of a tooltip when writing C code.

But the alternative is IMO much worse: there will be _no_ way
whatsoever to reach those windows via next_window.

The default is already not to consider those windows, so why it is a
problem that they are considered when the code explicitly requests to
consider _all_ the windows?

> Think of minibuf.c's
> 
>        struct frame *sf = XFRAME (selected_frame);
>        /* I don't think that any frames may validly have a null minibuffer
> 	 window anymore.  */
>        if (NILP (sf->minibuffer_window))
> 	emacs_abort ();

That's about the selected-frame, and tooltip frames should never be
selected.  Right?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 17 Mar 2021 15:37:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Mar 17 11:37:07 2021
Received: from localhost ([127.0.0.1]:43823 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lMYEM-0002Cb-Ps
	for submit <at> debbugs.gnu.org; Wed, 17 Mar 2021 11:37:07 -0400
Received: from mout.gmx.net ([212.227.15.19]:37219)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1lMYEJ-0002Bt-ER
 for 47207 <at> debbugs.gnu.org; Wed, 17 Mar 2021 11:37:05 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1615995415;
 bh=RJeYoStC25OlSg9pMrsufRGPMX2jI+wOXjRadTjp5RM=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=eZkOTjQ1dOC3Qvl35rs4nc4HILZPW2+h9DgiFyUoOw2koelOFDyjTC85Et1VS4o5m
 UutqHUKXZbJeRdbcfSvyGeWb6XfXQ08ZKT/rUDasjpMNQgTUq3DoMMC/+53p6bsERa
 pwtILQKc6ATSNiGE3ubcVb83LBqL2ggpH7rsZZAE=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([46.125.249.77]) by mail.gmx.net (mrgmx005
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1MPog5-1l0MXU16cF-00MwXc; Wed, 17
 Mar 2021 16:36:55 +0100
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
To: Eli Zaretskii <eliz@HIDDEN>
References: <c8442033-ac9b-f9e0-d5f5-3d649a874c3f@HIDDEN>
 <83r1kddi2r.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <37300876-70d1-c741-8a4d-97d024fdf6cf@HIDDEN>
Date: Wed, 17 Mar 2021 16:36:53 +0100
MIME-Version: 1.0
In-Reply-To: <83r1kddi2r.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:2D9Cwd5iEftIXo8CWZvAHe4Gf6BwFcXF6q9YjvXphsNaPNr40Ey
 ed623U04Z9OHjs4FiQf0QUmZfyXCq4SeUDjUBo5rW9wfQTEvK9FbGN0uovPzrgfwVYzAt54
 yUZQ79jEn7/vhd/sinynEt8DwCzUvIEvyU7VYt2w2VOXZCn8CVyH8ylrMfKwEGa6noQjIu6
 gWiWJLef9JcyZhY71pAaw==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:MHu6V0P/XoI=:l6udEKxeDBAP52TOtmy3cj
 5zHHJ3CqkVioGrpgojEZVdPMJRkGCTRQEA+hhlzVBDlwNS51gQyX+Hrx8+QcIpqa5H1aZ+ndA
 LmyQGVczg+q+tijkwh/gjnglz9DEhqAFtI8CtKlhd/BKdn5IDI8bOE+GveBSDdhZyWmwkAZo5
 TrGIU8ToB0pooTUwWZoiCaK0eOQo4rJBpV9x5VAY4rFvXcWjGQYl54XiFsdsFOXQoamFq0a5B
 DktbsW24MkXikFfOZ05TUabD1oVGOrlmTnyJsRscun2/buy9Bv6YEH3ZwuL4IWUFSVdzHq6/Z
 JHri1qjlR0wdzKeyG0DwHhghnM/2W9SUmRpXva8r0SyoO3eQov7CMea8Nc+EmqrPiGEM+X3w+
 9BxF1FUf7oj8dN+Vbm9Djd21M97HkxmTiTqhKMpf7puI8u5yvjWrFiKAJbawv/m2v3B3WW7f9
 /44DKyHXoKHiip/oz1VDudlVgAf+X0OhFtQnYT5EoX4oWZ55OHQrWwGzgH/SLlSmjB8hCiAgi
 fseh2c7U2UILwUHLHuYRU37oWMx63i7hGysNcScfFjydU3WW0+jH4/3P/Jqug5332V1MHVc4f
 MGT/etMWgXmoOWGHhvIsS/59QhCaFUBndlvDV+xXmRRTEngnSMiGUL6rEQveRgdcMIIi2VU0s
 +qGGY+5RoCVU1jvvJRu5W3SNxisKw/2AWidFKzBFP8ne9wW4x3A4KFP/01yoJQpHtIkAzSaI/
 z3WGo1dKkb3DLplQ8uskLS69Ww9EG2x2hcfhGS4daJryijkE1d98E0Vv7mXf/u69WY/flhS9a
 q0828HxZix/XmEN14/yHYJgpMFCfMH9YsVLB5Ae8h6iy2DQrljXfbkf0x0XYLeJMtVNTa93xt
 egPN/Ml0Rz3Udbaf333w==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47207
Cc: acm@HIDDEN, 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 >> #0  0x00000000005a5f85 in terminate_due_to_signal (sig=6, backtrace_limit=2147483647) at ../../src/emacs.c:379
 >> #1  0x0000000000651df0 in die (msg=0x788ee1 "WINDOWP (a)", file=0x788ece "../../src/window.h", line=543) at ../../src/alloc.c:7420
 >> #2  0x00000000004bdca6 in XWINDOW (a=XIL(0)) at ../../src/window.h:543
 >> #3  0x00000000004c6a4d in decode_next_window_args (window=0x7fffffffa808, minibuf=0x7fffffffa800, all_frames=0x7fffffffa7f8) at ../../src/window.c:2891
 >> #4  0x00000000004c6bff in next_window (window=XIL(0x2b04405), minibuf=XIL(0), all_frames=XIL(0x30), next_p=true) at ../../src/window.c:2927
 >
 > Do you have local changes in window.c?  The line numbers are about 200
 > lines off the current sources.

Sorry.  The following backtrace is from a fairly recent master.


Thread 1 "emacs" hit Breakpoint 1, terminate_due_to_signal (sig=6, backtrace_limit=2147483647) at ../../src/emacs.c:379
379	  signal (sig, SIG_DFL);
(gdb) bt
#0  0x00000000005ac554 in terminate_due_to_signal (sig=6, backtrace_limit=2147483647) at ../../src/emacs.c:379
#1  0x0000000000658972 in die (msg=0x7900b9 "WINDOWP (a)", file=0x7900a6 "../../src/window.h", line=472) at ../../src/alloc.c:7420
#2  0x00000000004c6efc in XWINDOW (a=XIL(0)) at ../../src/window.h:472
#3  0x00000000004d1897 in decode_next_window_args (window=0x7fffffffa808, minibuf=0x7fffffffa800, all_frames=0x7fffffffa7f8) at ../../src/window.c:2672
#4  0x00000000004d1a49 in next_window (window=XIL(0x2abb4b5), minibuf=XIL(0), all_frames=XIL(0x30), next_p=true) at ../../src/window.c:2708
#5  0x00000000004d1ed0 in Fnext_window (window=XIL(0x2abb4b5), minibuf=XIL(0), all_frames=XIL(0x30)) at ../../src/window.c:2804
#6  0x0000000000691a93 in funcall_subr (subr=0xc52760 <Snext_window>, numargs=3, args=0x7fffffffa9d0) at ../../src/eval.c:2992
#7  0x0000000000691510 in Ffuncall (nargs=4, args=0x7fffffffa9c8) at ../../src/eval.c:2914
#8  0x00000000006eb040 in exec_byte_code (bytestr=XIL(0x7ffff40a9b14), vector=XIL(0x7ffff3cc7245), maxdepth=make_fixnum(12), args_template=make_fixnum(769), nargs=2, args=0x7fffffffaf68) at ../../src/bytecode.c:632
#9  0x0000000000691cc8 in fetch_and_exec_byte_code (fun=XIL(0x7ffff3cc71ed), syms_left=make_fixnum(769), nargs=2, args=0x7fffffffaf58) at ../../src/eval.c:3036
#10 0x000000000069214e in funcall_lambda (fun=XIL(0x7ffff3cc71ed), nargs=2, arg_vector=0x7fffffffaf58) at ../../src/eval.c:3117
#11 0x0000000000691554 in Ffuncall (nargs=3, args=0x7fffffffaf50) at ../../src/eval.c:2916
#12 0x00000000006eb040 in exec_byte_code (bytestr=XIL(0x1ab0764), vector=XIL(0x197fefd), maxdepth=make_fixnum(7), args_template=make_fixnum(256), nargs=0, args=0x7fffffffb4a0) at ../../src/bytecode.c:632
#13 0x0000000000691cc8 in fetch_and_exec_byte_code (fun=XIL(0x197ff9d), syms_left=make_fixnum(256), nargs=0, args=0x7fffffffb4a0) at ../../src/eval.c:3036
#14 0x000000000069214e in funcall_lambda (fun=XIL(0x197ff9d), nargs=0, arg_vector=0x7fffffffb4a0) at ../../src/eval.c:3117
#15 0x0000000000691554 in Ffuncall (nargs=1, args=0x7fffffffb498) at ../../src/eval.c:2916
#16 0x00000000006eb040 in exec_byte_code (bytestr=XIL(0x1a6ced4), vector=XIL(0x195e1f5), maxdepth=make_fixnum(9), args_template=make_fixnum(514), nargs=2, args=0x7fffffffba68) at ../../src/bytecode.c:632
#17 0x0000000000691cc8 in fetch_and_exec_byte_code (fun=XIL(0x195e2dd), syms_left=make_fixnum(514), nargs=2, args=0x7fffffffba58) at ../../src/eval.c:3036
#18 0x000000000069214e in funcall_lambda (fun=XIL(0x195e2dd), nargs=2, arg_vector=0x7fffffffba58) at ../../src/eval.c:3117
#19 0x0000000000691554 in Ffuncall (nargs=3, args=0x7fffffffba50) at ../../src/eval.c:2916
#20 0x00000000006eb040 in exec_byte_code (bytestr=XIL(0x1a0a974), vector=XIL(0x195ded5), maxdepth=make_fixnum(8), args_template=make_fixnum(771), nargs=3, args=0x7fffffffbfc0) at ../../src/bytecode.c:632
#21 0x0000000000691cc8 in fetch_and_exec_byte_code (fun=XIL(0x193f76d), syms_left=make_fixnum(771), nargs=3, args=0x7fffffffbfa8) at ../../src/eval.c:3036
#22 0x000000000069214e in funcall_lambda (fun=XIL(0x193f76d), nargs=3, arg_vector=0x7fffffffbfa8) at ../../src/eval.c:3117
#23 0x0000000000691554 in Ffuncall (nargs=4, args=0x7fffffffbfa0) at ../../src/eval.c:2916
#24 0x00000000006eb040 in exec_byte_code (bytestr=XIL(0x1acf284), vector=XIL(0x18d0a6d), maxdepth=make_fixnum(17), args_template=make_fixnum(2312), nargs=9, args=0x7fffffffcb10) at ../../src/bytecode.c:632
#25 0x0000000000691cc8 in fetch_and_exec_byte_code (fun=XIL(0x18d0e8d), syms_left=make_fixnum(2312), nargs=9, args=0x7fffffffcac8) at ../../src/eval.c:3036
#26 0x000000000069214e in funcall_lambda (fun=XIL(0x18d0e8d), nargs=9, arg_vector=0x7fffffffcac8) at ../../src/eval.c:3117
#27 0x0000000000691554 in Ffuncall (nargs=10, args=0x7fffffffcac0) at ../../src/eval.c:2916
#28 0x00000000006eb040 in exec_byte_code (bytestr=XIL(0x19cf9b4), vector=XIL(0x168d8b5), maxdepth=make_fixnum(25), args_template=make_fixnum(1541), nargs=5, args=0x7fffffffd0f8) at ../../src/bytecode.c:632
#29 0x0000000000691cc8 in fetch_and_exec_byte_code (fun=XIL(0x168d92d), syms_left=make_fixnum(1541), nargs=5, args=0x7fffffffd0d0) at ../../src/eval.c:3036
#30 0x000000000069214e in funcall_lambda (fun=XIL(0x168d92d), nargs=5, arg_vector=0x7fffffffd0d0) at ../../src/eval.c:3117
#31 0x0000000000691554 in Ffuncall (nargs=6, args=0x7fffffffd0c8) at ../../src/eval.c:2916
#32 0x00000000006eb040 in exec_byte_code (bytestr=XIL(0x19cfb94), vector=XIL(0x1172b95), maxdepth=make_fixnum(10), args_template=make_fixnum(1026), nargs=2, args=0x7fffffffd540) at ../../src/bytecode.c:632
#33 0x0000000000691cc8 in fetch_and_exec_byte_code (fun=XIL(0x1702115), syms_left=make_fixnum(1026), nargs=2, args=0x7fffffffd530) at ../../src/eval.c:3036
#34 0x000000000069214e in funcall_lambda (fun=XIL(0x1702115), nargs=2, arg_vector=0x7fffffffd530) at ../../src/eval.c:3117
#35 0x0000000000691e72 in apply_lambda (fun=XIL(0x1702115), args=XIL(0x1a76453), count=9) at ../../src/eval.c:3061
#36 0x000000000068ffbc in eval_sub (form=XIL(0x1a76493)) at ../../src/eval.c:2436
#37 0x000000000068a172 in Fprogn (body=XIL(0)) at ../../src/eval.c:462
#38 0x0000000000692605 in funcall_lambda (fun=XIL(0x1a58a53), nargs=0, arg_vector=0x0) at ../../src/eval.c:3184
#39 0x0000000000691667 in Ffuncall (nargs=1, args=0x7fffffffda88) at ../../src/eval.c:2928
#40 0x000000000068576a in Ffuncall_interactively (nargs=1, args=0x7fffffffda88) at ../../src/callint.c:260
#41 0x000000000069193a in funcall_subr (subr=0xc5dce0 <Sfuncall_interactively>, numargs=1, args=0x7fffffffda88) at ../../src/eval.c:2967
#42 0x0000000000691510 in Ffuncall (nargs=2, args=0x7fffffffda80) at ../../src/eval.c:2914
#43 0x0000000000690311 in Fapply (nargs=3, args=0x7fffffffda80) at ../../src/eval.c:2497
#44 0x0000000000685bf2 in Fcall_interactively (function=XIL(0xd0a900), record_flag=XIL(0), keys=XIL(0x7ffff437d235)) at ../../src/callint.c:353
#45 0x0000000000691a93 in funcall_subr (subr=0xc5dd20 <Scall_interactively>, numargs=3, args=0x7fffffffdd40) at ../../src/eval.c:2992
#46 0x0000000000691510 in Ffuncall (nargs=4, args=0x7fffffffdd38) at ../../src/eval.c:2914
#47 0x00000000006eb040 in exec_byte_code (bytestr=XIL(0x7ffff3d87ac4), vector=XIL(0x7ffff3d8772d), maxdepth=make_fixnum(13), args_template=make_fixnum(1025), nargs=1, args=0x7fffffffe2b0) at ../../src/bytecode.c:632
#48 0x0000000000691cc8 in fetch_and_exec_byte_code (fun=XIL(0x7ffff3d876fd), syms_left=make_fixnum(1025), nargs=1, args=0x7fffffffe2a8) at ../../src/eval.c:3036
#49 0x000000000069214e in funcall_lambda (fun=XIL(0x7ffff3d876fd), nargs=1, arg_vector=0x7fffffffe2a8) at ../../src/eval.c:3117
#50 0x0000000000691554 in Ffuncall (nargs=2, args=0x7fffffffe2a0) at ../../src/eval.c:2916
#51 0x0000000000690e40 in call1 (fn=XIL(0x42f0), arg1=XIL(0xd0a900)) at ../../src/eval.c:2774
#52 0x00000000005b43ea in command_loop_1 () at ../../src/keyboard.c:1466
#53 0x000000000068d36c in internal_condition_case (bfun=0x5b3b91 <command_loop_1>, handlers=XIL(0x90), hfun=0x5b31a0 <cmd_error>) at ../../src/eval.c:1439
#54 0x00000000005b3776 in command_loop_2 (ignore=XIL(0)) at ../../src/keyboard.c:1094
#55 0x000000000068c778 in internal_catch (tag=XIL(0xd5f0), func=0x5b3749 <command_loop_2>, arg=XIL(0)) at ../../src/eval.c:1189
#56 0x00000000005b3714 in command_loop () at ../../src/keyboard.c:1073
#57 0x00000000005b2c87 in recursive_edit_1 () at ../../src/keyboard.c:720
#58 0x00000000005b2e7f in Frecursive_edit () at ../../src/keyboard.c:789
#59 0x00000000005aed56 in main (argc=1, argv=0x7fffffffe7c8) at ../../src/emacs.c:2050

Lisp Backtrace:
"next-window" (0xffffa9d0)
"other-window" (0xffffaf58)
"ediff-skip-unsuitable-frames" (0xffffb4a0)
"ediff-prepare-error-list" (0xffffba58)
"ediff-setup-diff-regions" (0xffffbfa8)
"ediff-setup" (0xffffcac8)
"ediff-buffers-internal" (0xffffd0d0)
"ediff-buffers" (0xffffd530)
"my-diffs-b" (0xffffda90)
"funcall-interactively" (0xffffda88)
"call-interactively" (0xffffdd40)
"command-execute" (0xffffe2a8)
(gdb) frame 3
#3  0x00000000004d1897 in decode_next_window_args (window=0x7fffffffa808, minibuf=0x7fffffffa800, all_frames=0x7fffffffa7f8) at ../../src/window.c:2672
2672	    *minibuf = this_minibuffer_depth (XWINDOW (miniwin)->contents)
(gdb) p miniwin
$1 = XIL(0)
(gdb) frame 5
#5  0x00000000004d1ed0 in Fnext_window (window=XIL(0x2abb4b5), minibuf=XIL(0), all_frames=XIL(0x30)) at ../../src/window.c:2804
2804	  return next_window (window, minibuf, all_frames, true);
(gdb) p XWINDOW (window)->contents
$2 = XIL(0x10f3195)
(gdb) xpr
Lisp_Vectorlike
PVEC_BUFFER
$3 = (struct buffer *) 0x10f3190
0x1db57b8 " *tip*"
(gdb)


 >> we probably should decide whether to consider tooltip windows in
 >> `next-window' or `other-window' at all.
 >
 > Not sure why.  Don't we envision some applications that would like to
 > examine tooltip windows?  IOW, that tooltip frames don't have a
 > minibuffer doesn't necessarily mean we don't want to give window
 > iterations access to tooltip windows.

But then people must be always careful to never look into the minibuffer
window of a tooltip when writing C code.  Think of minibuf.c's

       struct frame *sf = XFRAME (selected_frame);
       /* I don't think that any frames may validly have a null minibuffer
	 window anymore.  */
       if (NILP (sf->minibuffer_window))
	emacs_abort ();

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at 47207 <at> debbugs.gnu.org:


Received: (at 47207) by debbugs.gnu.org; 17 Mar 2021 13:29:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Mar 17 09:29:48 2021
Received: from localhost ([127.0.0.1]:42351 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lMWF9-0004tA-U6
	for submit <at> debbugs.gnu.org; Wed, 17 Mar 2021 09:29:48 -0400
Received: from eggs.gnu.org ([209.51.188.92]:52148)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lMWF8-0004sv-3Z
 for 47207 <at> debbugs.gnu.org; Wed, 17 Mar 2021 09:29:46 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:35980)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lMWF1-0008Hr-M1; Wed, 17 Mar 2021 09:29:39 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1733
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lMWEx-0000Kb-KB; Wed, 17 Mar 2021 09:29:37 -0400
Date: Wed, 17 Mar 2021 15:29:32 +0200
Message-Id: <83r1kddi2r.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
In-Reply-To: <c8442033-ac9b-f9e0-d5f5-3d649a874c3f@HIDDEN> (message from
 martin rudalics on Wed, 17 Mar 2021 09:45:21 +0100)
Subject: Re: bug#47207: 28.0.50; decode_next_window_args crash
References: <c8442033-ac9b-f9e0-d5f5-3d649a874c3f@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47207
Cc: acm@HIDDEN, 47207 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: martin rudalics <rudalics@HIDDEN>
> Date: Wed, 17 Mar 2021 09:45:21 +0100
> Cc: Alan Mackenzie <acm@HIDDEN>
> 
> The following bug has hit me out of the blue a couple of times.  Trying
> to ediff two buffers gets me the crash below:
> 
> 
> #0  0x00000000005a5f85 in terminate_due_to_signal (sig=6, backtrace_limit=2147483647) at ../../src/emacs.c:379
> #1  0x0000000000651df0 in die (msg=0x788ee1 "WINDOWP (a)", file=0x788ece "../../src/window.h", line=543) at ../../src/alloc.c:7420
> #2  0x00000000004bdca6 in XWINDOW (a=XIL(0)) at ../../src/window.h:543
> #3  0x00000000004c6a4d in decode_next_window_args (window=0x7fffffffa808, minibuf=0x7fffffffa800, all_frames=0x7fffffffa7f8) at ../../src/window.c:2891
> #4  0x00000000004c6bff in next_window (window=XIL(0x2b04405), minibuf=XIL(0), all_frames=XIL(0x30), next_p=true) at ../../src/window.c:2927

Do you have local changes in window.c?  The line numbers are about 200
lines off the current sources.

> we probably should decide whether to consider tooltip windows in
> `next-window' or `other-window' at all.

Not sure why.  Don't we envision some applications that would like to
examine tooltip windows?  IOW, that tooltip frames don't have a
minibuffer doesn't necessarily mean we don't want to give window
iterations access to tooltip windows.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 17 Mar 2021 08:45:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Mar 17 04:45:38 2021
Received: from localhost ([127.0.0.1]:41899 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lMRo9-0003jz-7w
	for submit <at> debbugs.gnu.org; Wed, 17 Mar 2021 04:45:37 -0400
Received: from lists.gnu.org ([209.51.188.17]:46320)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1lMRo7-0003jq-44
 for submit <at> debbugs.gnu.org; Wed, 17 Mar 2021 04:45:35 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:60062)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <rudalics@HIDDEN>) id 1lMRo5-0004E0-17
 for bug-gnu-emacs@HIDDEN; Wed, 17 Mar 2021 04:45:34 -0400
Received: from mout.gmx.net ([212.227.17.20]:56475)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <rudalics@HIDDEN>) id 1lMRo0-0007zb-0Y
 for bug-gnu-emacs@HIDDEN; Wed, 17 Mar 2021 04:45:32 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1615970723;
 bh=dq0kI3cevHdDKUthavQnAxEGUdVbkZivPswlyOBBZms=;
 h=X-UI-Sender-Class:To:Cc:From:Subject:Date;
 b=l31fMxUGXq0gz3NYLPBaM9ASoSwsLoDPTT1VQdCIOoj5/ES3ToreYtGhBKTC6dzVf
 GSxePaayy5juZ2E9fK2eiDlWsAfyJrhV4LiXqi4T8BW82W62H16KyisTEqjCgyv0mJ
 sbk58SMUd1kzhR0PYiM6f6T0lQHPniDTUT+Ztmj4=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([46.125.249.77]) by mail.gmx.net (mrgmx104
 [212.227.17.168]) with ESMTPSA (Nemesis) id 1N5mKJ-1lkm9A0xGl-017AMc; Wed, 17
 Mar 2021 09:45:23 +0100
To: Bug-Gnu-Emacs <bug-gnu-emacs@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Subject: 28.0.50; decode_next_window_args crash
Message-ID: <c8442033-ac9b-f9e0-d5f5-3d649a874c3f@HIDDEN>
Date: Wed, 17 Mar 2021 09:45:21 +0100
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="------------AD4405D0F47339962EB4E17A"
Content-Language: en-US
X-Provags-ID: V03:K1:KezwJH5GzrbmPt3A/q/zANi8N4y5i8nz9d13T4iZX8bwbSAWgbm
 ZnJreJ08GQK/1DNXr5vCZJDrLFBWvaLLnerG0u+i0XUEpngst2bklWWhdYKffmAofhwAgOe
 LQxMrmUPGFekN1nm8rtkHat7WRde8ULgnen0Jd/0AinePoKnL8wfVDwfSuPuaYMAFWvMqU7
 qs/2GHFchp4BGx7yqBpUg==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:6D+ghEQXPv0=:TXfHHJgkF/k2qW+eu9EWZ8
 0jB8t8qtQbGAZH0ciVkuzKQxKe7SueObniV9A5cN7KVydi9pOvY0yhdunowB98jNLPRTz9EZY
 PTcX1WnI3wBUEmHKKV4I+cw/5Yr2LDUJi0HL5RvfQqasJre8WVNOsgGpLTL0r4Q7DRoNMHlCp
 p7mCtVVR/lG7FtNgPRaXtgxduaarNHtvs50HOYtKRVQyUWAqNe8H+ehGERRpDnP55mROiOPLb
 kMR3cia6Hc+Y1AqXB/psEzZcupiT+HffAayzALBUVhCxxLVvzoW+7ceoj7kK+9yMM55nEuPap
 yjyj7j+mdsu5kUkmhBGW6mYE7v2WgeLDaAGOCPZfWDtIcQXuP4P+8lclZu225zsg3wRK1WGhx
 R4iim24mhHMrnA+xawKgPJ5k2n7UNbwmhrfF0K1LOlqdexrxKiRQS9lWwaGAVH4W38yxAdyFF
 3paGz4FHdjqeshvMeJMKU2KSfcX20C6LaaYoBQQIWTJfAYcEXqbLPLbbzH7novQemCHQ5JeOA
 D8lDKO+QL3OhElUQLHW2wPORrLNVIlEgIoQ+wRDZH0+CQVVZPJQCT79UYLTEMrmrzQ18ZfUzt
 V7M4TDK1E5gzbiBzXWrJxztF2q8+/RHdQXCU+YuEPreJEgs1+5kt2ivG7/XWP2zyP99J9FVFc
 iFgmOpLebbqn57i5e/7c76XjUJfqW7F+1CURBzzwYiGv47wBzGUrLda2YfNf4MKDdajC1TBed
 d7daqQMF+9fxVAvEUqY4eDIqx8UGsMMrS2TTyUFNvgwMAFcfYaU+pv5OhRrhizqIHQSRK16Rw
 BdlTATUy4v9pViOyLzwjOTNe+5I0U/+LvlaSJ92nQSfANGalLBn1fO8A7YuwDoytjIoptRFaL
 WA2/TIbcurEHjeZThgow==
Received-SPF: pass client-ip=212.227.17.20; envelope-from=rudalics@HIDDEN;
 helo=mout.gmx.net
X-Spam_score_int: -25
X-Spam_score: -2.6
X-Spam_bar: --
X-Spam_report: (-2.6 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, FREEMAIL_FROM=0.001, RCVD_IN_DNSWL_LOW=-0.7,
 RCVD_IN_MSPIKE_H2=-0.001, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
Cc: Alan Mackenzie <acm@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

This is a multi-part message in MIME format.
--------------AD4405D0F47339962EB4E17A
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: 7bit

The following bug has hit me out of the blue a couple of times.  Trying
to ediff two buffers gets me the crash below:


#0  0x00000000005a5f85 in terminate_due_to_signal (sig=6, backtrace_limit=2147483647) at ../../src/emacs.c:379
#1  0x0000000000651df0 in die (msg=0x788ee1 "WINDOWP (a)", file=0x788ece "../../src/window.h", line=543) at ../../src/alloc.c:7420
#2  0x00000000004bdca6 in XWINDOW (a=XIL(0)) at ../../src/window.h:543
#3  0x00000000004c6a4d in decode_next_window_args (window=0x7fffffffa808, minibuf=0x7fffffffa800, all_frames=0x7fffffffa7f8) at ../../src/window.c:2891
#4  0x00000000004c6bff in next_window (window=XIL(0x2b04405), minibuf=XIL(0), all_frames=XIL(0x30), next_p=true) at ../../src/window.c:2927
#5  0x00000000004c7086 in Fnext_window (window=XIL(0x2b04405), minibuf=XIL(0), all_frames=XIL(0x30)) at ../../src/window.c:3023
#6  0x000000000068b298 in funcall_subr (subr=0xc4b6e0 <Snext_window>, numargs=3, args=0x7fffffffa9d0) at ../../src/eval.c:2996
#7  0x000000000068ad15 in Ffuncall (nargs=4, args=0x7fffffffa9c8) at ../../src/eval.c:2918
#8  0x00000000006e4865 in exec_byte_code (bytestr=XIL(0x7ffff3cc5764), vector=XIL(0x7ffff3cc5255), maxdepth=make_fixnum(12), args_template=make_fixnum(769), nargs=2, args=0x7fffffffaf68) at ../../src/bytecode.c:632
#9  0x000000000068b4cd in fetch_and_exec_byte_code (fun=XIL(0x7ffff3cc51fd), syms_left=make_fixnum(769), nargs=2, args=0x7fffffffaf58) at ../../src/eval.c:3040
#10 0x000000000068b953 in funcall_lambda (fun=XIL(0x7ffff3cc51fd), nargs=2, arg_vector=0x7fffffffaf58) at ../../src/eval.c:3121
#11 0x000000000068ad59 in Ffuncall (nargs=3, args=0x7fffffffaf50) at ../../src/eval.c:2920
#12 0x00000000006e4865 in exec_byte_code (bytestr=XIL(0x1b2c854), vector=XIL(0x1a0010d), maxdepth=make_fixnum(7), args_template=make_fixnum(256), nargs=0, args=0x7fffffffb4a0) at ../../src/bytecode.c:632
#13 0x000000000068b4cd in fetch_and_exec_byte_code (fun=XIL(0x1a001ad), syms_left=make_fixnum(256), nargs=0, args=0x7fffffffb4a0) at ../../src/eval.c:3040
#14 0x000000000068b953 in funcall_lambda (fun=XIL(0x1a001ad), nargs=0, arg_vector=0x7fffffffb4a0) at ../../src/eval.c:3121
#15 0x000000000068ad59 in Ffuncall (nargs=1, args=0x7fffffffb498) at ../../src/eval.c:2920
#16 0x00000000006e4865 in exec_byte_code (bytestr=XIL(0x1b09454), vector=XIL(0x1988f85), maxdepth=make_fixnum(9), args_template=make_fixnum(514), nargs=2, args=0x7fffffffba68) at ../../src/bytecode.c:632
#17 0x000000000068b4cd in fetch_and_exec_byte_code (fun=XIL(0x198906d), syms_left=make_fixnum(514), nargs=2, args=0x7fffffffba58) at ../../src/eval.c:3040
#18 0x000000000068b953 in funcall_lambda (fun=XIL(0x198906d), nargs=2, arg_vector=0x7fffffffba58) at ../../src/eval.c:3121
#19 0x000000000068ad59 in Ffuncall (nargs=3, args=0x7fffffffba50) at ../../src/eval.c:2920
#20 0x00000000006e4865 in exec_byte_code (bytestr=XIL(0x1b08c04), vector=XIL(0x1988ba5), maxdepth=make_fixnum(8), args_template=make_fixnum(771), nargs=3, args=0x7fffffffbfc0) at ../../src/bytecode.c:632
#21 0x000000000068b4cd in fetch_and_exec_byte_code (fun=XIL(0x1988c45), syms_left=make_fixnum(771), nargs=3, args=0x7fffffffbfa8) at ../../src/eval.c:3040
#22 0x000000000068b953 in funcall_lambda (fun=XIL(0x1988c45), nargs=3, arg_vector=0x7fffffffbfa8) at ../../src/eval.c:3121
#23 0x000000000068ad59 in Ffuncall (nargs=4, args=0x7fffffffbfa0) at ../../src/eval.c:2920
#24 0x00000000006e4865 in exec_byte_code (bytestr=XIL(0x1b41884), vector=XIL(0x1a037f5), maxdepth=make_fixnum(17), args_template=make_fixnum(2312), nargs=9, args=0x7fffffffcb10) at ../../src/bytecode.c:632
#25 0x000000000068b4cd in fetch_and_exec_byte_code (fun=XIL(0x1aa7c75), syms_left=make_fixnum(2312), nargs=9, args=0x7fffffffcac8) at ../../src/eval.c:3040
#26 0x000000000068b953 in funcall_lambda (fun=XIL(0x1aa7c75), nargs=9, arg_vector=0x7fffffffcac8) at ../../src/eval.c:3121
#27 0x000000000068ad59 in Ffuncall (nargs=10, args=0x7fffffffcac0) at ../../src/eval.c:2920
#28 0x00000000006e4865 in exec_byte_code (bytestr=XIL(0x1a187b4), vector=XIL(0x1123095), maxdepth=make_fixnum(25), args_template=make_fixnum(1541), nargs=5, args=0x7fffffffd0f8) at ../../src/bytecode.c:632
#29 0x000000000068b4cd in fetch_and_exec_byte_code (fun=XIL(0x112310d), syms_left=make_fixnum(1541), nargs=5, args=0x7fffffffd0d0) at ../../src/eval.c:3040
#30 0x000000000068b953 in funcall_lambda (fun=XIL(0x112310d), nargs=5, arg_vector=0x7fffffffd0d0) at ../../src/eval.c:3121
#31 0x000000000068ad59 in Ffuncall (nargs=6, args=0x7fffffffd0c8) at ../../src/eval.c:2920
#32 0x00000000006e4865 in exec_byte_code (bytestr=XIL(0x1a18a34), vector=XIL(0x1616e2d), maxdepth=make_fixnum(10), args_template=make_fixnum(1026), nargs=2, args=0x7fffffffd540) at ../../src/bytecode.c:632
#33 0x000000000068b4cd in fetch_and_exec_byte_code (fun=XIL(0x1a7257d), syms_left=make_fixnum(1026), nargs=2, args=0x7fffffffd530) at ../../src/eval.c:3040
#34 0x000000000068b953 in funcall_lambda (fun=XIL(0x1a7257d), nargs=2, arg_vector=0x7fffffffd530) at ../../src/eval.c:3121
#35 0x000000000068b677 in apply_lambda (fun=XIL(0x1a7257d), args=XIL(0x1afad93), count=9) at ../../src/eval.c:3065
#36 0x00000000006897c1 in eval_sub (form=XIL(0x1afadd3)) at ../../src/eval.c:2440
#37 0x000000000068391a in Fprogn (body=XIL(0)) at ../../src/eval.c:462
#38 0x000000000068be0a in funcall_lambda (fun=XIL(0x1afab83), nargs=0, arg_vector=0x0) at ../../src/eval.c:3188
#39 0x000000000068ae6c in Ffuncall (nargs=1, args=0x7fffffffda88) at ../../src/eval.c:2932
#40 0x000000000067ef12 in Ffuncall_interactively (nargs=1, args=0x7fffffffda88) at ../../src/callint.c:260
#41 0x000000000068b13f in funcall_subr (subr=0xc570a0 <Sfuncall_interactively>, numargs=1, args=0x7fffffffda88) at ../../src/eval.c:2971
#42 0x000000000068ad15 in Ffuncall (nargs=2, args=0x7fffffffda80) at ../../src/eval.c:2918
#43 0x0000000000689b16 in Fapply (nargs=3, args=0x7fffffffda80) at ../../src/eval.c:2501
#44 0x000000000067f39a in Fcall_interactively (function=XIL(0xd1edf0), record_flag=XIL(0), keys=XIL(0x7ffff437c805)) at ../../src/callint.c:353
#45 0x000000000068b298 in funcall_subr (subr=0xc570e0 <Scall_interactively>, numargs=3, args=0x7fffffffdd40) at ../../src/eval.c:2996
#46 0x000000000068ad15 in Ffuncall (nargs=4, args=0x7fffffffdd38) at ../../src/eval.c:2918
#47 0x00000000006e4865 in exec_byte_code (bytestr=XIL(0x7ffff3d7c80c), vector=XIL(0x7ffff3d7c125), maxdepth=make_fixnum(13), args_template=make_fixnum(1025), nargs=1, args=0x7fffffffe2b0) at ../../src/bytecode.c:632
#48 0x000000000068b4cd in fetch_and_exec_byte_code (fun=XIL(0x7ffff3d7c0f5), syms_left=make_fixnum(1025), nargs=1, args=0x7fffffffe2a8) at ../../src/eval.c:3040
#49 0x000000000068b953 in funcall_lambda (fun=XIL(0x7ffff3d7c0f5), nargs=1, arg_vector=0x7fffffffe2a8) at ../../src/eval.c:3121
#50 0x000000000068ad59 in Ffuncall (nargs=2, args=0x7fffffffe2a0) at ../../src/eval.c:2920
#51 0x000000000068a645 in call1 (fn=XIL(0x4230), arg1=XIL(0xd1edf0)) at ../../src/eval.c:2778
#52 0x00000000005ade1b in command_loop_1 () at ../../src/keyboard.c:1466
#53 0x0000000000686b71 in internal_condition_case (bfun=0x5ad5c2 <command_loop_1>, handlers=XIL(0x90), hfun=0x5acbd1 <cmd_error>) at ../../src/eval.c:1443
#54 0x00000000005ad1a7 in command_loop_2 (ignore=XIL(0)) at ../../src/keyboard.c:1094
#55 0x0000000000685f7d in internal_catch (tag=XIL(0xd6b0), func=0x5ad17a <command_loop_2>, arg=XIL(0)) at ../../src/eval.c:1193
#56 0x00000000005ad145 in command_loop () at ../../src/keyboard.c:1073
#57 0x00000000005ac6b8 in recursive_edit_1 () at ../../src/keyboard.c:720
#58 0x00000000005ac8b0 in Frecursive_edit () at ../../src/keyboard.c:789
#59 0x00000000005a8787 in main (argc=1, argv=0x7fffffffe7c8) at ../../src/emacs.c:2050

Lisp Backtrace:
"next-window" (0xffffa9d0)
"other-window" (0xffffaf58)
"ediff-skip-unsuitable-frames" (0xffffb4a0)
"ediff-prepare-error-list" (0xffffba58)
"ediff-setup-diff-regions" (0xffffbfa8)
"ediff-setup" (0xffffcac8)
"ediff-buffers-internal" (0xffffd0d0)
"ediff-buffers" (0xffffd530)
"my-diffs-b" (0xffffda90)
"funcall-interactively" (0xffffda88)
"call-interactively" (0xffffdd40)
"command-execute" (0xffffe2a8)
(gdb) frame 3
#3  0x00000000004c6a4d in decode_next_wMajor mode: Text

Minor modes in effect:
   pop-up-mini-mode: t
   shell-dirtrack-mode: t
   scroll-restore-mode: t
   show-paren-mode: t
   tooltip-mode: t
   electric-indent-mode: t
   mouse-wheel-mode: t
   menu-bar-mode: t
   file-name-shadow-mode: t
   global-font-lock-mode: t
   font-lock-mode: t
   auto-composition-mode: t
   auto-encryption-mode: t
   auto-compression-mode: t
   temp-buffer-resize-mode: t
   column-number-mode: t
   line-number-mode: t
   auto-fill-function: do-auto-fill
   transient-mark-mode: t

Load-path shadows:
None found.

Features:
(shadow mail-extr warnings emacsbug message rmc puny rfc822 mml mml-sec
epa derived epg epg-config gnus-util rmail rmail-loaddefs auth-source
password-cache json map mm-decode mm-bodies mm-encode mail-parse rfc2231
mailabbrev gmm-utils mailheader sendmail rfc2047 rfc2045 ietf-drums
mm-util mail-prsvr mail-utils smerge-mode diff mule-util eieio-opt
cl-extra speedbar ezimage dframe dabbrev etags fileloop generator xref
cl-seq project eieio eieio-core eieio-loaddefs minibuf-eldef time-date
subr-x shortdoc thingatpt help-fns radix-tree help-mode speck cl-macs
pop-up-mini vc cc-mode cc-fonts cc-guess cc-menus cc-cmds cc-styles
cc-align cc-engine cc-vars cc-defs vc-git diff-mode vc-dispatcher
bug-reference elp ediff-vers ediff ediff-merg ediff-mult ediff-wind
ediff-diff ediff-help ediff-init ediff-util local-tags info-look
find-func elinfo-support elinfo texinfo info shell pcomplete comint
ansi-color ring sidebar bookmark seq byte-opt bytecomp byte-compile
cconv text-property-search sort m&d scroll-restore regexp-lock
time-stamp eldoc-tooltip pcase easy-mmode find-dired dired
dired-loaddefs cus-edit pp cus-start cus-load wid-edit cl-loaddefs
cl-lib jka-compr paren ls-lisp gv iso-transl tooltip eldoc electric
uniquify ediff-hook vc-hooks lisp-float-type mwheel term/x-win x-win
term/common-win x-dnd tool-bar dnd fontset image regexp-opt fringe
tabulated-list replace newcomment text-mode elisp-mode lisp-mode
prog-mode register page tab-bar menu-bar rfn-eshadow isearch easymenu
timer select scroll-bar mouse jit-lock font-lock syntax facemenu
font-core term/tty-colors frame minibuffer cl-generic cham georgian
utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao korean
japanese eucjp-ms cp51932 hebrew greek romanian slovak czech european
ethiopic indian cyrillic chinese composite charscript charprop
case-table epa-hook jka-cmpr-hook help simple abbrev obarray
cl-preloaded nadvice button loaddefs faces cus-face macroexp files
window text-properties overlay sha1 md5 base64 format env code-pages
mule custom widget hashtable-print-readable backquote threads dbusbind
inotify dynamic-setting system-font-setting font-render-setting cairo
move-toolbar gtk x-toolkit x multi-tty make-network-process emacs)

Memory information:
((conses 16 328334 70021)
  (symbols 48 17143 1)
  (strings 32 52277 4856)
  (string-bytes 1 1699127)
  (vectors 16 33942)
  (vector-slots 8 1202337 161897)
  (floats 8 170 554)
  (intervals 56 19456 1549)
  (buffers 1008 42))
indow_args (window=0x7fffffffa808, minibuf=0x7fffffffa800, all_frames=0x7fffffffa7f8) at ../../src/window.c:2891
2891	    *minibuf = this_minibuffer_depth (XWINDOW (miniwin)->contents)
(gdb) p miniwin
$1 = XIL(0)
(gdb) frame 5
#5  0x00000000004c7086 in Fnext_window (window=XIL(0x2b04405), minibuf=XIL(0), all_frames=XIL(0x30)) at ../../src/window.c:3023
3023	  return next_window (window, minibuf, all_frames, true);
(gdb) p window
$4 = XIL(0x2b04405)
(gdb) p XWINDOW (window)->contents
$5 = XIL(0x2d46a85)
(gdb) xpr
Lisp_Vectorlike
PVEC_BUFFER
$6 = (struct buffer *) 0x2d46a80
0x1fadde8 " *tip*"
(gdb)


Presumably, commit c7c154bb5756e0ae71d342c5d8aabf725877f186 is directly
responsible for the crash.  It's triggered by the

(other-window 1 t)

call in `ediff-skip-unsuitable-frames' which selects the tooltip window
which has no minibuffer.  Patch attached, but we probably should decide
whether to consider tooltip windows in `next-window' or `other-window'
at all.  See also

https://lists.gnu.org/archive/html/emacs-devel/2018-02/msg00694.html

martin

--------------AD4405D0F47339962EB4E17A
Content-Type: text/x-patch;
 name="window.c.diff"
Content-Transfer-Encoding: 7bit
Content-Disposition: attachment;
 filename="window.c.diff"

diff --git a/src/window.c b/src/window.c
index eb16e2a433..6da804bbd9 100644
--- a/src/window.c
+++ b/src/window.c
@@ -2668,7 +2668,7 @@ decode_next_window_args (Lisp_Object *window, Lisp_Object *minibuf, Lisp_Object
   XSETWINDOW (*window, w);
   /* MINIBUF nil may or may not include minibuffers.  Decide if it
      does.  */
-  if (NILP (*minibuf))
+  if (WINDOWP (miniwin) & NILP (*minibuf))
     *minibuf = this_minibuffer_depth (XWINDOW (miniwin)->contents)
       ? miniwin
       : Qlambda;
@@ -2682,9 +2682,7 @@ decode_next_window_args (Lisp_Object *window, Lisp_Object *minibuf, Lisp_Object
   /* ALL_FRAMES nil doesn't specify which frames to include.  */
   if (NILP (*all_frames))
     *all_frames
-      = (!EQ (*minibuf, Qlambda)
-	 ? FRAME_MINIBUF_WINDOW (XFRAME (w->frame))
-	 : Qnil);
+      = (WINDOWP (miniwin) && !EQ (*minibuf, Qlambda)) ? miniwin : Qnil;
   else if (EQ (*all_frames, Qvisible))
     ;
   else if (EQ (*all_frames, make_fixnum (0)))

--------------AD4405D0F47339962EB4E17A--




Acknowledgement sent to martin rudalics <rudalics@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#47207; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Sun, 18 Apr 2021 08:15:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.